/* game-area.c generated by valac 0.56.16, the Vala compiler
 * generated from game-area.vala, do not modify */

/*
 * Copyright 2020-2023 Andrey Kutejko <andy128k@gmail.com>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, see <http://www.gnu.org/licenses/>.
 *
 * For more details see the file COPYING.
 */

#include <gtk/gtk.h>
#include <glib-object.h>
#include <gio/gio.h>
#include <glib.h>
#include <gdk/gdk.h>
#include <stdlib.h>
#include <string.h>
#include <float.h>
#include <math.h>
#include <graphene-gobject.h>
#include <glib/gi18n-lib.h>

#define GAME_AREA_MINIMUM_TILE_WIDTH 8
#define GAME_AREA_MINIMUM_TILE_HEIGHT 8
#define GAME_AREA_ANIMATION_DELAY 100
#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define TYPE_GAME_AREA (game_area_get_type ())
#define GAME_AREA(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_GAME_AREA, GameArea))
#define GAME_AREA_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_GAME_AREA, GameAreaClass))
#define IS_GAME_AREA(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_GAME_AREA))
#define IS_GAME_AREA_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_GAME_AREA))
#define GAME_AREA_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_GAME_AREA, GameAreaClass))

typedef struct _GameArea GameArea;
typedef struct _GameAreaClass GameAreaClass;
typedef struct _GameAreaPrivate GameAreaPrivate;

#define TYPE_GAME (game_get_type ())
#define GAME(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_GAME, Game))
#define GAME_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_GAME, GameClass))
#define IS_GAME(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_GAME))
#define IS_GAME_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_GAME))
#define GAME_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_GAME, GameClass))

typedef struct _Game Game;
typedef struct _GameClass GameClass;

#define TYPE_GAME_CONFIGS (game_configs_get_type ())
#define GAME_CONFIGS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_GAME_CONFIGS, GameConfigs))
#define GAME_CONFIGS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_GAME_CONFIGS, GameConfigsClass))
#define IS_GAME_CONFIGS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_GAME_CONFIGS))
#define IS_GAME_CONFIGS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_GAME_CONFIGS))
#define GAME_CONFIGS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_GAME_CONFIGS, GameConfigsClass))

typedef struct _GameConfigs GameConfigs;
typedef struct _GameConfigsClass GameConfigsClass;

#define TYPE_ASSETS (assets_get_type ())
#define ASSETS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_ASSETS, Assets))
#define IS_ASSETS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_ASSETS))
#define ASSETS_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), TYPE_ASSETS, AssetsIface))

typedef struct _Assets Assets;
typedef struct _AssetsIface AssetsIface;

#define TYPE_BUBBLE (bubble_get_type ())
#define BUBBLE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_BUBBLE, Bubble))
#define BUBBLE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_BUBBLE, BubbleClass))
#define IS_BUBBLE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_BUBBLE))
#define IS_BUBBLE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_BUBBLE))
#define BUBBLE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_BUBBLE, BubbleClass))

typedef struct _Bubble Bubble;
typedef struct _BubbleClass BubbleClass;

#define TYPE_THEME (theme_get_type ())
#define THEME(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_THEME, Theme))
#define THEME_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_THEME, ThemeClass))
#define IS_THEME(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_THEME))
#define IS_THEME_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_THEME))
#define THEME_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_THEME, ThemeClass))

typedef struct _Theme Theme;
typedef struct _ThemeClass ThemeClass;

#define TYPE_ANIMATED (animated_get_type ())
#define ANIMATED(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_ANIMATED, Animated))
#define ANIMATED_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_ANIMATED, AnimatedClass))
#define IS_ANIMATED(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_ANIMATED))
#define IS_ANIMATED_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_ANIMATED))
#define ANIMATED_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_ANIMATED, AnimatedClass))

typedef struct _Animated Animated;
typedef struct _AnimatedClass AnimatedClass;

#define TYPE_SOUND_PLAYER (sound_player_get_type ())
#define SOUND_PLAYER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SOUND_PLAYER, SoundPlayer))
#define SOUND_PLAYER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SOUND_PLAYER, SoundPlayerClass))
#define IS_SOUND_PLAYER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SOUND_PLAYER))
#define IS_SOUND_PLAYER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SOUND_PLAYER))
#define SOUND_PLAYER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SOUND_PLAYER, SoundPlayerClass))

typedef struct _SoundPlayer SoundPlayer;
typedef struct _SoundPlayerClass SoundPlayerClass;

#define TYPE_PROPERTIES (properties_get_type ())
#define PROPERTIES(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PROPERTIES, Properties))
#define PROPERTIES_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PROPERTIES, PropertiesClass))
#define IS_PROPERTIES(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PROPERTIES))
#define IS_PROPERTIES_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PROPERTIES))
#define PROPERTIES_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PROPERTIES, PropertiesClass))

typedef struct _Properties Properties;
typedef struct _PropertiesClass PropertiesClass;
enum  {
	GAME_AREA_0_PROPERTY,
	GAME_AREA_THEME_PROPERTY,
	GAME_AREA_BACKGROUND_COLOR_PROPERTY,
	GAME_AREA_BACKGROUND_COLOR_NAME_PROPERTY,
	GAME_AREA_NUM_PROPERTIES
};
static GParamSpec* game_area_properties[GAME_AREA_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _game_unref0(var) ((var == NULL) ? NULL : (var = (game_unref (var), NULL)))
#define _game_configs_unref0(var) ((var == NULL) ? NULL : (var = (game_configs_unref (var), NULL)))
#define _animated_unref0(var) ((var == NULL) ? NULL : (var = (animated_unref (var), NULL)))
#define _sound_player_unref0(var) ((var == NULL) ? NULL : (var = (sound_player_unref (var), NULL)))
#define _properties_unref0(var) ((var == NULL) ? NULL : (var = (properties_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))

#define TYPE_GAME_CONFIG (game_config_get_type ())
typedef struct _GameConfig GameConfig;
#define _game_config_free0(var) ((var == NULL) ? NULL : (var = (game_config_free (var), NULL)))

#define TYPE_ARENA (arena_get_type ())
#define ARENA(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_ARENA, Arena))
#define ARENA_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_ARENA, ArenaClass))
#define IS_ARENA(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_ARENA))
#define IS_ARENA_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_ARENA))
#define ARENA_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_ARENA, ArenaClass))

typedef struct _Arena Arena;
typedef struct _ArenaClass ArenaClass;
typedef enum  {
	THEME_FRAMES_PLAYER_START = 0,
	THEME_FRAMES_PLAYER_DEAD = 4,
	THEME_FRAMES_ROBOT1_START = 5,
	THEME_FRAMES_ROBOT2_START = 9,
	THEME_FRAMES_HEAP_START = 13,
	THEME_FRAMES_COUNT = 14,
	THEME_FRAMES_NUM_PLAYER_ANIMATIONS = THEME_FRAMES_PLAYER_DEAD - THEME_FRAMES_PLAYER_START,
	THEME_FRAMES_NUM_PLAYER_DEAD_ANIMATIONS = THEME_FRAMES_ROBOT1_START - THEME_FRAMES_PLAYER_DEAD,
	THEME_FRAMES_NUM_PLAYER_TILES = THEME_FRAMES_ROBOT1_START - THEME_FRAMES_PLAYER_START,
	THEME_FRAMES_NUM_ROBOT1_ANIMATIONS = THEME_FRAMES_ROBOT2_START - THEME_FRAMES_ROBOT1_START,
	THEME_FRAMES_NUM_ROBOT2_ANIMATIONS = THEME_FRAMES_HEAP_START - THEME_FRAMES_ROBOT2_START,
	THEME_FRAMES_NUM_HEAP_ANIMATIONS = THEME_FRAMES_COUNT - THEME_FRAMES_HEAP_START
} ThemeFrames;

#define THEME_TYPE_FRAMES (theme_frames_get_type ())
typedef enum  {
	GAME_EVENT_TELEPORTED,
	GAME_EVENT_SPLAT,
	GAME_EVENT_LEVEL_COMPLETE,
	GAME_EVENT_DEATH,
	GAME_EVENT_SCORED,
	GAME_EVENT_VICTORY,
	GAME_EVENT_NO_TELEPORT_LOCATIONS,
	GAME_EVENT_NO_SAFE_TELEPORT_LOCATIONS
} GameEvent;

#define GAME_TYPE_EVENT (game_event_get_type ())
typedef enum  {
	OBJECT_TYPE_PLAYER = 0,
	OBJECT_TYPE_HEAP = 1,
	OBJECT_TYPE_ROBOT1 = 2,
	OBJECT_TYPE_ROBOT2 = 3,
	OBJECT_TYPE_NONE = 99
} ObjectType;

#define TYPE_OBJECT_TYPE (object_type_get_type ())

#define ARENA_TYPE_COORDS (arena_coords_get_type ())
typedef struct _ArenaCoords ArenaCoords;
typedef enum  {
	GAME_STATE_PLAYING = 1,
	GAME_STATE_WAITING,
	GAME_STATE_COMPLETE,
	GAME_STATE_DEAD,
	GAME_STATE_TYPE2,
	GAME_STATE_WAITING_TYPE2
} GameState;

#define GAME_TYPE_STATE (game_state_get_type ())
typedef enum  {
	PLAYER_COMMAND_NW = 0,
	PLAYER_COMMAND_N,
	PLAYER_COMMAND_NE,
	PLAYER_COMMAND_W,
	PLAYER_COMMAND_STAY,
	PLAYER_COMMAND_E,
	PLAYER_COMMAND_SW,
	PLAYER_COMMAND_S,
	PLAYER_COMMAND_SE,
	PLAYER_COMMAND_SAFE_TELEPORT,
	PLAYER_COMMAND_RANDOM_TELEPORT,
	PLAYER_COMMAND_WAIT
} PlayerCommand;

#define TYPE_PLAYER_COMMAND (player_command_get_type ())
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
typedef enum  {
	GAME_MOVE_SAFETY_UNSAFE,
	GAME_MOVE_SAFETY_SAFE,
	GAME_MOVE_SAFETY_SUPER_SAFE
} GameMoveSafety;

#define GAME_TYPE_MOVE_SAFETY (game_move_safety_get_type ())
typedef enum  {
	SOUND_VICTORY = 0,
	SOUND_DIE,
	SOUND_TELEPORT,
	SOUND_SPLAT,
	SOUND_YAHOO,
	SOUND_BAD
} Sound;

#define TYPE_SOUND (sound_get_type ())
enum  {
	GAME_AREA_UPDATED_SIGNAL,
	GAME_AREA_ADD_SCORE_SIGNAL,
	GAME_AREA_NUM_SIGNALS
};
static guint game_area_signals[GAME_AREA_NUM_SIGNALS] = {0};

struct _GameArea {
	GtkWidget parent_instance;
	GameAreaPrivate * priv;
};

struct _GameAreaClass {
	GtkWidgetClass parent_class;
};

struct _AssetsIface {
	GTypeInterface parent_iface;
	GListStore* (*get_themes) (Assets* self);
	Bubble* (*get_aieee_bubble) (Assets* self);
	Bubble* (*get_yahoo_bubble) (Assets* self);
	Bubble* (*get_splat_bubble) (Assets* self);
	GArray* (*get_cursors) (Assets* self);
};

struct _GameAreaPrivate {
	GtkGestureClick* click_controller;
	GtkEventControllerMotion* motion_controller;
	Game* game;
	GameConfigs* game_configs;
	Assets* assets;
	Theme* _theme;
	GdkRGBA light_background;
	GdkRGBA dark_background;
	guint timer_id;
	Animated* player_animation;
	Animated* player_dead_animation;
	Animated* robot1_animation;
	Animated* robot2_animation;
	SoundPlayer* sound_player;
	Properties* properties;
};

struct _GameConfig {
	gchar* description;
	gint initial_type1;
	gint initial_type2;
	gint increment_type1;
	gint increment_type2;
	gint maximum_type1;
	gint maximum_type2;
	gint score_type1;
	gint score_type2;
	gint score_type1_waiting;
	gint score_type2_waiting;
	gint score_type1_splatted;
	gint score_type2_splatted;
	gint num_robots_per_safe;
	gint safe_score_boundary;
	gint initial_safe_teleports;
	gint free_safe_teleports;
	gint max_safe_teleports;
	gboolean moveable_heaps;
};

struct _ArenaCoords {
	gint x;
	gint y;
};

static gint GameArea_private_offset;
static gpointer game_area_parent_class = NULL;

VALA_EXTERN GType game_area_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GameArea, g_object_unref)
VALA_EXTERN gpointer game_ref (gpointer instance);
VALA_EXTERN void game_unref (gpointer instance);
VALA_EXTERN GParamSpec* param_spec_game (const gchar* name,
                             const gchar* nick,
                             const gchar* blurb,
                             GType object_type,
                             GParamFlags flags);
VALA_EXTERN void value_set_game (GValue* value,
                     gpointer v_object);
VALA_EXTERN void value_take_game (GValue* value,
                      gpointer v_object);
VALA_EXTERN gpointer value_get_game (const GValue* value);
VALA_EXTERN GType game_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Game, game_unref)
VALA_EXTERN gpointer game_configs_ref (gpointer instance);
VALA_EXTERN void game_configs_unref (gpointer instance);
VALA_EXTERN GParamSpec* param_spec_game_configs (const gchar* name,
                                     const gchar* nick,
                                     const gchar* blurb,
                                     GType object_type,
                                     GParamFlags flags);
VALA_EXTERN void value_set_game_configs (GValue* value,
                             gpointer v_object);
VALA_EXTERN void value_take_game_configs (GValue* value,
                              gpointer v_object);
VALA_EXTERN gpointer value_get_game_configs (const GValue* value);
VALA_EXTERN GType game_configs_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GameConfigs, game_configs_unref)
VALA_EXTERN gpointer bubble_ref (gpointer instance);
VALA_EXTERN void bubble_unref (gpointer instance);
VALA_EXTERN GParamSpec* param_spec_bubble (const gchar* name,
                               const gchar* nick,
                               const gchar* blurb,
                               GType object_type,
                               GParamFlags flags);
VALA_EXTERN void value_set_bubble (GValue* value,
                       gpointer v_object);
VALA_EXTERN void value_take_bubble (GValue* value,
                        gpointer v_object);
VALA_EXTERN gpointer value_get_bubble (const GValue* value);
VALA_EXTERN GType bubble_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Bubble, bubble_unref)
VALA_EXTERN GType assets_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Assets, g_object_unref)
VALA_EXTERN GType theme_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Theme, g_object_unref)
VALA_EXTERN gpointer animated_ref (gpointer instance);
VALA_EXTERN void animated_unref (gpointer instance);
VALA_EXTERN GParamSpec* param_spec_animated (const gchar* name,
                                 const gchar* nick,
                                 const gchar* blurb,
                                 GType object_type,
                                 GParamFlags flags);
VALA_EXTERN void value_set_animated (GValue* value,
                         gpointer v_object);
VALA_EXTERN void value_take_animated (GValue* value,
                          gpointer v_object);
VALA_EXTERN gpointer value_get_animated (const GValue* value);
VALA_EXTERN GType animated_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Animated, animated_unref)
VALA_EXTERN gpointer sound_player_ref (gpointer instance);
VALA_EXTERN void sound_player_unref (gpointer instance);
VALA_EXTERN GParamSpec* param_spec_sound_player (const gchar* name,
                                     const gchar* nick,
                                     const gchar* blurb,
                                     GType object_type,
                                     GParamFlags flags);
VALA_EXTERN void value_set_sound_player (GValue* value,
                             gpointer v_object);
VALA_EXTERN void value_take_sound_player (GValue* value,
                              gpointer v_object);
VALA_EXTERN gpointer value_get_sound_player (const GValue* value);
VALA_EXTERN GType sound_player_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (SoundPlayer, sound_player_unref)
VALA_EXTERN gpointer properties_ref (gpointer instance);
VALA_EXTERN void properties_unref (gpointer instance);
VALA_EXTERN GParamSpec* param_spec_properties (const gchar* name,
                                   const gchar* nick,
                                   const gchar* blurb,
                                   GType object_type,
                                   GParamFlags flags);
VALA_EXTERN void value_set_properties (GValue* value,
                           gpointer v_object);
VALA_EXTERN void value_take_properties (GValue* value,
                            gpointer v_object);
VALA_EXTERN gpointer value_get_properties (const GValue* value);
VALA_EXTERN GType properties_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Properties, properties_unref)
VALA_EXTERN GameArea* game_area_new (Game* game,
                         GameConfigs* game_configs,
                         Assets* assets,
                         SoundPlayer* sound_player,
                         Properties* properties,
                         GError** error);
VALA_EXTERN GameArea* game_area_construct (GType object_type,
                               Game* game,
                               GameConfigs* game_configs,
                               Assets* assets,
                               SoundPlayer* sound_player,
                               Properties* properties,
                               GError** error);
VALA_EXTERN void properties_get_bgcolour (Properties* self,
                              GdkRGBA * result);
VALA_EXTERN void game_area_set_background_color (GameArea* self,
                                     GdkRGBA * value);
VALA_EXTERN Theme* themes_find_best_match (GListModel* themes,
                               const gchar* name,
                               GError** error);
VALA_EXTERN GListStore* assets_get_themes (Assets* self);
VALA_EXTERN gchar* properties_get_theme (Properties* self);
VALA_EXTERN GType game_config_get_type (void) G_GNUC_CONST ;
VALA_EXTERN GameConfig* game_config_dup (const GameConfig* self);
VALA_EXTERN void game_config_free (GameConfig* self);
VALA_EXTERN void game_config_copy (const GameConfig* self,
                       GameConfig* dest);
VALA_EXTERN void game_config_destroy (GameConfig* self);
G_DEFINE_AUTO_CLEANUP_CLEAR_FUNC (GameConfig, game_config_destroy)
VALA_EXTERN GameConfig* game_configs_find_by_name (GameConfigs* self,
                                       const gchar* name);
VALA_EXTERN gchar* properties_get_selected_config (Properties* self);
VALA_EXTERN GameConfig* game_configs_get (GameConfigs* self,
                              guint n);
VALA_EXTERN void game_set_config (Game* self,
                      GameConfig * value);
static void __lambda30_ (GameArea* self,
                  gint n_pressed,
                  gdouble x,
                  gdouble y);
static void game_area_mouse_cb (GameArea* self,
                         gint n_press,
                         gdouble x,
                         gdouble y);
static void ___lambda30__gtk_gesture_click_pressed (GtkGestureClick* _sender,
                                             gint n_press,
                                             gdouble x,
                                             gdouble y,
                                             gpointer self);
static void __lambda31_ (GameArea* self,
                  gdouble x,
                  gdouble y);
static void game_area_move_cb (GameArea* self,
                        gdouble x,
                        gdouble y);
static void ___lambda31__gtk_event_controller_motion_motion (GtkEventControllerMotion* _sender,
                                                      gdouble x,
                                                      gdouble y,
                                                      gpointer self);
VALA_EXTERN gpointer arena_ref (gpointer instance);
VALA_EXTERN void arena_unref (gpointer instance);
VALA_EXTERN GParamSpec* param_spec_arena (const gchar* name,
                              const gchar* nick,
                              const gchar* blurb,
                              GType object_type,
                              GParamFlags flags);
VALA_EXTERN void value_set_arena (GValue* value,
                      gpointer v_object);
VALA_EXTERN void value_take_arena (GValue* value,
                       gpointer v_object);
VALA_EXTERN gpointer value_get_arena (const GValue* value);
VALA_EXTERN GType arena_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Arena, arena_unref)
VALA_EXTERN Arena* game_get_arena (Game* self);
VALA_EXTERN gint arena_get_width (Arena* self);
VALA_EXTERN gint arena_get_height (Arena* self);
VALA_EXTERN Animated* animated_sequence (gint start,
                             gint step);
VALA_EXTERN GType theme_frames_get_type (void) G_GNUC_CONST ;
VALA_EXTERN Animated* animated_limit (Animated* self,
                          gint count);
VALA_EXTERN Animated* animated_then (Animated* self,
                         Animated* another);
VALA_EXTERN Animated* animated_bounce (gint start,
                           gint limit);
VALA_EXTERN Animated* animated_repeat (Animated* self,
                           gint count);
VALA_EXTERN Animated* animated_forever (Animated* self);
static gboolean game_area_timer_cb (GameArea* self);
static gboolean _game_area_timer_cb_gsource_func (gpointer self);
VALA_EXTERN GType game_event_get_type (void) G_GNUC_CONST ;
static void game_area_on_game_event (GameArea* self,
                              GameEvent event,
                              gint param);
static void _game_area_on_game_event_game_game_event (Game* _sender,
                                               GameEvent event,
                                               gint param,
                                               gpointer self);
static void game_area_properties_changed_cb (GameArea* self);
static void _game_area_properties_changed_cb_properties_changed (Properties* _sender,
                                                          gpointer self);
VALA_EXTERN void game_area_start_new_game (GameArea* self);
static void game_area_tile_size (GameArea* self,
                          graphene_size_t* result);
static void game_area_real_snapshot (GtkWidget* base,
                              GtkSnapshot* snapshot);
VALA_EXTERN GType object_type_get_type (void) G_GNUC_CONST ;
static void game_area_draw_object (GameArea* self,
                            gint x,
                            gint y,
                            ObjectType type,
                            GtkSnapshot* snapshot,
                            graphene_rect_t* tile_rect);
VALA_EXTERN ObjectType arena_get (Arena* self,
                      gint x,
                      gint y);
VALA_EXTERN GType arena_coords_get_type (void) G_GNUC_CONST ;
VALA_EXTERN ArenaCoords* arena_coords_dup (const ArenaCoords* self);
VALA_EXTERN void arena_coords_free (ArenaCoords* self);
VALA_EXTERN ArenaCoords* game_get_splat (Game* self);
VALA_EXTERN Bubble* assets_get_splat_bubble (Assets* self);
VALA_EXTERN void bubble_draw (Bubble* self,
                  GtkSnapshot* snapshot,
                  gfloat x,
                  gfloat y);
VALA_EXTERN GType game_state_get_type (void) G_GNUC_CONST ;
VALA_EXTERN GameState game_get_state (Game* self);
VALA_EXTERN Bubble* assets_get_aieee_bubble (Assets* self);
VALA_EXTERN void game_get_player (Game* self,
                      ArenaCoords * result);
VALA_EXTERN Bubble* assets_get_yahoo_bubble (Assets* self);
static gint game_area_object_animation_frame (GameArea* self,
                                       ObjectType type);
VALA_EXTERN Theme* game_area_get_theme (GameArea* self);
VALA_EXTERN void theme_draw_object (Theme* self,
                        ObjectType type,
                        gint frame_no,
                        GtkSnapshot* snapshot,
                        graphene_rect_t* rect);
VALA_EXTERN gint animated_get_frame (Animated* self);
VALA_EXTERN gint animated_tick (Animated* self);
VALA_EXTERN void game_tick (Game* self);
static void game_area_get_dir (GameArea* self,
                        gdouble ix,
                        gdouble iy,
                        gint* odx,
                        gint* ody);
VALA_EXTERN GType player_command_get_type (void) G_GNUC_CONST ;
VALA_EXTERN PlayerCommand player_command_from_direction (gint dx,
                                             gint dy);
VALA_EXTERN void game_area_player_command (GameArea* self,
                               PlayerCommand cmd);
VALA_EXTERN GArray* assets_get_cursors (Assets* self);
VALA_EXTERN void game_get_config (Game* self,
                      GameConfig * result);
VALA_EXTERN gchar* game_config_name (GameConfig *self);
VALA_EXTERN const gchar* theme_get_name (Theme* self);
VALA_EXTERN void game_area_set_theme (GameArea* self,
                          Theme* value);
VALA_EXTERN void game_start_new_game (Game* self);
VALA_EXTERN void game_area_set_game_config (GameArea* self,
                                GameConfig* game_config);
VALA_EXTERN GType game_move_safety_get_type (void) G_GNUC_CONST ;
VALA_EXTERN gboolean properties_get_safe_moves (Properties* self);
VALA_EXTERN gboolean properties_get_super_safe_moves (Properties* self);
VALA_EXTERN gboolean game_player_command (Game* self,
                              PlayerCommand cmd,
                              GameMoveSafety safety);
VALA_EXTERN GType sound_get_type (void) G_GNUC_CONST ;
static void game_area_play_sound (GameArea* self,
                           Sound sound);
static void game_area_log_score (GameArea* self,
                          gint score);
static void game_area_message_box (GameArea* self,
                            const gchar* msg);
VALA_EXTERN gboolean properties_get_sound (Properties* self);
VALA_EXTERN void sound_player_play (SoundPlayer* self,
                        Sound sound);
VALA_EXTERN void game_area_get_background_color (GameArea* self,
                                     GdkRGBA * result);
VALA_EXTERN void calculate_light_color (GdkRGBA* color,
                            GdkRGBA* result);
VALA_EXTERN gchar* game_area_get_background_color_name (GameArea* self);
VALA_EXTERN gchar* rgba_to_string (GdkRGBA* color);
VALA_EXTERN void game_area_set_background_color_name (GameArea* self,
                                          const gchar* value);
static void g_cclosure_user_marshal_VOID__GAME (GClosure * closure,
                                         GValue * return_value,
                                         guint n_param_values,
                                         const GValue * param_values,
                                         gpointer invocation_hint,
                                         gpointer marshal_data);
static void g_cclosure_user_marshal_VOID__STRING_INT (GClosure * closure,
                                               GValue * return_value,
                                               guint n_param_values,
                                               const GValue * param_values,
                                               gpointer invocation_hint,
                                               gpointer marshal_data);
static void game_area_finalize (GObject * obj);
static GType game_area_get_type_once (void);
static void _vala_game_area_get_property (GObject * object,
                                   guint property_id,
                                   GValue * value,
                                   GParamSpec * pspec);
static void _vala_game_area_set_property (GObject * object,
                                   guint property_id,
                                   const GValue * value,
                                   GParamSpec * pspec);

static inline gpointer
game_area_get_instance_private (GameArea* self)
{
	return G_STRUCT_MEMBER_P (self, GameArea_private_offset);
}

static gpointer
_game_ref0 (gpointer self)
{
#line 87 "../src/game-area.vala"
	return self ? game_ref (self) : NULL;
#line 641 "game-area.c"
}

static gpointer
_game_configs_ref0 (gpointer self)
{
#line 88 "../src/game-area.vala"
	return self ? game_configs_ref (self) : NULL;
#line 649 "game-area.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 89 "../src/game-area.vala"
	return self ? g_object_ref (self) : NULL;
#line 657 "game-area.c"
}

static gpointer
_sound_player_ref0 (gpointer self)
{
#line 92 "../src/game-area.vala"
	return self ? sound_player_ref (self) : NULL;
#line 665 "game-area.c"
}

static gpointer
_properties_ref0 (gpointer self)
{
#line 93 "../src/game-area.vala"
	return self ? properties_ref (self) : NULL;
#line 673 "game-area.c"
}

static void
__lambda30_ (GameArea* self,
             gint n_pressed,
             gdouble x,
             gdouble y)
{
#line 98 "../src/game-area.vala"
	game_area_mouse_cb (self, n_pressed, x, y);
#line 684 "game-area.c"
}

static void
___lambda30__gtk_gesture_click_pressed (GtkGestureClick* _sender,
                                        gint n_press,
                                        gdouble x,
                                        gdouble y,
                                        gpointer self)
{
#line 98 "../src/game-area.vala"
	__lambda30_ ((GameArea*) self, n_press, x, y);
#line 696 "game-area.c"
}

static void
__lambda31_ (GameArea* self,
             gdouble x,
             gdouble y)
{
#line 102 "../src/game-area.vala"
	game_area_move_cb (self, x, y);
#line 706 "game-area.c"
}

static void
___lambda31__gtk_event_controller_motion_motion (GtkEventControllerMotion* _sender,
                                                 gdouble x,
                                                 gdouble y,
                                                 gpointer self)
{
#line 102 "../src/game-area.vala"
	__lambda31_ ((GameArea*) self, x, y);
#line 717 "game-area.c"
}

static gboolean
_game_area_timer_cb_gsource_func (gpointer self)
{
	gboolean result;
	result = game_area_timer_cb ((GameArea*) self);
#line 132 "../src/game-area.vala"
	return result;
#line 727 "game-area.c"
}

static void
_game_area_on_game_event_game_game_event (Game* _sender,
                                          GameEvent event,
                                          gint param,
                                          gpointer self)
{
#line 134 "../src/game-area.vala"
	game_area_on_game_event ((GameArea*) self, event, param);
#line 738 "game-area.c"
}

static void
_game_area_properties_changed_cb_properties_changed (Properties* _sender,
                                                     gpointer self)
{
#line 136 "../src/game-area.vala"
	game_area_properties_changed_cb ((GameArea*) self);
#line 747 "game-area.c"
}

GameArea*
game_area_construct (GType object_type,
                     Game* game,
                     GameConfigs* game_configs,
                     Assets* assets,
                     SoundPlayer* sound_player,
                     Properties* properties,
                     GError** error)
{
	GameArea * self = NULL;
	Game* _tmp0_;
	GameConfigs* _tmp1_;
	Assets* _tmp2_;
	GdkRGBA _tmp3_ = {0};
	GdkRGBA _tmp4_;
	Theme* _tmp5_ = NULL;
	GListStore* _tmp6_;
	GListStore* _tmp7_;
	gchar* _tmp8_;
	gchar* _tmp9_;
	gchar* _tmp10_;
	Theme* _tmp11_;
	Theme* _tmp12_;
	Theme* _tmp13_;
	SoundPlayer* _tmp14_;
	Properties* _tmp15_;
	GameConfig* _tmp16_ = NULL;
	gchar* _tmp17_;
	gchar* _tmp18_;
	gchar* _tmp19_;
	GameConfig* _tmp20_;
	GameConfig* _tmp21_;
	GameConfig _tmp23_;
	GtkGestureClick* _tmp24_;
	GtkGestureClick* _tmp25_;
	GtkGestureClick* _tmp26_;
	GtkEventController* _tmp27_;
	GtkEventControllerMotion* _tmp28_;
	GtkEventControllerMotion* _tmp29_;
	GtkEventControllerMotion* _tmp30_;
	GtkEventController* _tmp31_;
	Arena* _tmp32_;
	Arena* _tmp33_;
	gint _tmp34_;
	gint _tmp35_;
	Arena* _tmp36_;
	Arena* _tmp37_;
	gint _tmp38_;
	gint _tmp39_;
	Animated* _tmp40_;
	Animated* _tmp41_;
	Animated* _tmp42_;
	Animated* _tmp43_;
	Animated* _tmp44_;
	Animated* _tmp45_;
	Animated* _tmp46_;
	Animated* _tmp47_;
	Animated* _tmp48_;
	Animated* _tmp49_;
	Animated* _tmp50_;
	Animated* _tmp51_;
	Animated* _tmp52_;
	Animated* _tmp53_;
	Animated* _tmp54_;
	Animated* _tmp55_;
	Animated* _tmp56_;
	Animated* _tmp57_;
	Animated* _tmp58_;
	Animated* _tmp59_;
	Animated* _tmp60_;
	Animated* _tmp61_;
	Animated* _tmp62_;
	Animated* _tmp63_;
	GError* _inner_error0_ = NULL;
#line 82 "../src/game-area.vala"
	g_return_val_if_fail (game != NULL, NULL);
#line 82 "../src/game-area.vala"
	g_return_val_if_fail (game_configs != NULL, NULL);
#line 82 "../src/game-area.vala"
	g_return_val_if_fail (assets != NULL, NULL);
#line 82 "../src/game-area.vala"
	g_return_val_if_fail (sound_player != NULL, NULL);
#line 82 "../src/game-area.vala"
	g_return_val_if_fail (properties != NULL, NULL);
#line 82 "../src/game-area.vala"
	self = (GameArea*) g_object_new (object_type, NULL);
#line 87 "../src/game-area.vala"
	_tmp0_ = _game_ref0 (game);
#line 87 "../src/game-area.vala"
	_game_unref0 (self->priv->game);
#line 87 "../src/game-area.vala"
	self->priv->game = _tmp0_;
#line 88 "../src/game-area.vala"
	_tmp1_ = _game_configs_ref0 (game_configs);
#line 88 "../src/game-area.vala"
	_game_configs_unref0 (self->priv->game_configs);
#line 88 "../src/game-area.vala"
	self->priv->game_configs = _tmp1_;
#line 89 "../src/game-area.vala"
	_tmp2_ = _g_object_ref0 (assets);
#line 89 "../src/game-area.vala"
	_g_object_unref0 (self->priv->assets);
#line 89 "../src/game-area.vala"
	self->priv->assets = _tmp2_;
#line 90 "../src/game-area.vala"
	properties_get_bgcolour (properties, &_tmp3_);
#line 90 "../src/game-area.vala"
	_tmp4_ = _tmp3_;
#line 90 "../src/game-area.vala"
	game_area_set_background_color (self, &_tmp4_);
#line 91 "../src/game-area.vala"
	_tmp6_ = assets_get_themes (assets);
#line 91 "../src/game-area.vala"
	_tmp7_ = _tmp6_;
#line 91 "../src/game-area.vala"
	_tmp8_ = properties_get_theme (properties);
#line 91 "../src/game-area.vala"
	_tmp9_ = _tmp8_;
#line 91 "../src/game-area.vala"
	_tmp10_ = _tmp9_;
#line 91 "../src/game-area.vala"
	_tmp11_ = themes_find_best_match ((GListModel*) _tmp7_, _tmp10_, &_inner_error0_);
#line 91 "../src/game-area.vala"
	_tmp12_ = _tmp11_;
#line 91 "../src/game-area.vala"
	_g_free0 (_tmp10_);
#line 91 "../src/game-area.vala"
	_tmp5_ = _tmp12_;
#line 91 "../src/game-area.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 91 "../src/game-area.vala"
		g_propagate_error (error, _inner_error0_);
#line 91 "../src/game-area.vala"
		_g_object_unref0 (self);
#line 91 "../src/game-area.vala"
		return NULL;
#line 886 "game-area.c"
	}
#line 91 "../src/game-area.vala"
	_tmp13_ = _tmp5_;
#line 91 "../src/game-area.vala"
	_tmp5_ = NULL;
#line 91 "../src/game-area.vala"
	_g_object_unref0 (self->priv->_theme);
#line 91 "../src/game-area.vala"
	self->priv->_theme = _tmp13_;
#line 92 "../src/game-area.vala"
	_tmp14_ = _sound_player_ref0 (sound_player);
#line 92 "../src/game-area.vala"
	_sound_player_unref0 (self->priv->sound_player);
#line 92 "../src/game-area.vala"
	self->priv->sound_player = _tmp14_;
#line 93 "../src/game-area.vala"
	_tmp15_ = _properties_ref0 (properties);
#line 93 "../src/game-area.vala"
	_properties_unref0 (self->priv->properties);
#line 93 "../src/game-area.vala"
	self->priv->properties = _tmp15_;
#line 95 "../src/game-area.vala"
	_tmp17_ = properties_get_selected_config (properties);
#line 95 "../src/game-area.vala"
	_tmp18_ = _tmp17_;
#line 95 "../src/game-area.vala"
	_tmp19_ = _tmp18_;
#line 95 "../src/game-area.vala"
	_tmp20_ = game_configs_find_by_name (game_configs, _tmp19_);
#line 95 "../src/game-area.vala"
	_tmp21_ = _tmp20_;
#line 95 "../src/game-area.vala"
	_g_free0 (_tmp19_);
#line 95 "../src/game-area.vala"
	_tmp16_ = _tmp21_;
#line 95 "../src/game-area.vala"
	if (_tmp16_ == NULL) {
#line 924 "game-area.c"
		GameConfig* _tmp22_;
#line 95 "../src/game-area.vala"
		_tmp22_ = game_configs_get (game_configs, (guint) 0);
#line 95 "../src/game-area.vala"
		_game_config_free0 (_tmp16_);
#line 95 "../src/game-area.vala"
		_tmp16_ = _tmp22_;
#line 932 "game-area.c"
	}
#line 95 "../src/game-area.vala"
	_tmp23_ = *_tmp16_;
#line 95 "../src/game-area.vala"
	game_set_config (game, &_tmp23_);
#line 97 "../src/game-area.vala"
	_tmp24_ = (GtkGestureClick*) gtk_gesture_click_new ();
#line 97 "../src/game-area.vala"
	_g_object_unref0 (self->priv->click_controller);
#line 97 "../src/game-area.vala"
	self->priv->click_controller = _tmp24_;
#line 98 "../src/game-area.vala"
	_tmp25_ = self->priv->click_controller;
#line 98 "../src/game-area.vala"
	g_signal_connect_object (_tmp25_, "pressed", (GCallback) ___lambda30__gtk_gesture_click_pressed, self, 0);
#line 99 "../src/game-area.vala"
	_tmp26_ = self->priv->click_controller;
#line 99 "../src/game-area.vala"
	_tmp27_ = _g_object_ref0 ((GtkEventController*) _tmp26_);
#line 99 "../src/game-area.vala"
	gtk_widget_add_controller ((GtkWidget*) self, _tmp27_);
#line 101 "../src/game-area.vala"
	_tmp28_ = (GtkEventControllerMotion*) gtk_event_controller_motion_new ();
#line 101 "../src/game-area.vala"
	_g_object_unref0 (self->priv->motion_controller);
#line 101 "../src/game-area.vala"
	self->priv->motion_controller = _tmp28_;
#line 102 "../src/game-area.vala"
	_tmp29_ = self->priv->motion_controller;
#line 102 "../src/game-area.vala"
	g_signal_connect_object (_tmp29_, "motion", (GCallback) ___lambda31__gtk_event_controller_motion_motion, self, 0);
#line 103 "../src/game-area.vala"
	_tmp30_ = self->priv->motion_controller;
#line 103 "../src/game-area.vala"
	_tmp31_ = _g_object_ref0 ((GtkEventController*) _tmp30_);
#line 103 "../src/game-area.vala"
	gtk_widget_add_controller ((GtkWidget*) self, _tmp31_);
#line 105 "../src/game-area.vala"
	_tmp32_ = game_get_arena (game);
#line 105 "../src/game-area.vala"
	_tmp33_ = _tmp32_;
#line 105 "../src/game-area.vala"
	_tmp34_ = arena_get_width (_tmp33_);
#line 105 "../src/game-area.vala"
	_tmp35_ = _tmp34_;
#line 105 "../src/game-area.vala"
	_tmp36_ = game_get_arena (game);
#line 105 "../src/game-area.vala"
	_tmp37_ = _tmp36_;
#line 105 "../src/game-area.vala"
	_tmp38_ = arena_get_height (_tmp37_);
#line 105 "../src/game-area.vala"
	_tmp39_ = _tmp38_;
#line 105 "../src/game-area.vala"
	gtk_widget_set_size_request ((GtkWidget*) self, GAME_AREA_MINIMUM_TILE_WIDTH * _tmp35_, GAME_AREA_MINIMUM_TILE_HEIGHT * _tmp39_);
#line 108 "../src/game-area.vala"
	_tmp40_ = animated_sequence ((gint) THEME_FRAMES_PLAYER_START, 0);
#line 108 "../src/game-area.vala"
	_tmp41_ = _tmp40_;
#line 108 "../src/game-area.vala"
	_tmp42_ = animated_limit (_tmp41_, 20);
#line 108 "../src/game-area.vala"
	_tmp43_ = _tmp42_;
#line 108 "../src/game-area.vala"
	_tmp44_ = animated_bounce ((gint) THEME_FRAMES_PLAYER_START, (gint) THEME_FRAMES_NUM_PLAYER_ANIMATIONS);
#line 108 "../src/game-area.vala"
	_tmp45_ = _tmp44_;
#line 108 "../src/game-area.vala"
	_tmp46_ = animated_repeat (_tmp45_, 2);
#line 108 "../src/game-area.vala"
	_tmp47_ = _tmp46_;
#line 108 "../src/game-area.vala"
	_tmp48_ = animated_then (_tmp43_, _tmp47_);
#line 108 "../src/game-area.vala"
	_tmp49_ = _tmp48_;
#line 108 "../src/game-area.vala"
	_tmp50_ = animated_forever (_tmp49_);
#line 108 "../src/game-area.vala"
	_animated_unref0 (self->priv->player_animation);
#line 108 "../src/game-area.vala"
	self->priv->player_animation = _tmp50_;
#line 108 "../src/game-area.vala"
	_animated_unref0 (_tmp49_);
#line 108 "../src/game-area.vala"
	_animated_unref0 (_tmp47_);
#line 108 "../src/game-area.vala"
	_animated_unref0 (_tmp45_);
#line 108 "../src/game-area.vala"
	_animated_unref0 (_tmp43_);
#line 108 "../src/game-area.vala"
	_animated_unref0 (_tmp41_);
#line 118 "../src/game-area.vala"
	_tmp51_ = animated_bounce ((gint) THEME_FRAMES_PLAYER_DEAD, (gint) THEME_FRAMES_NUM_PLAYER_DEAD_ANIMATIONS);
#line 118 "../src/game-area.vala"
	_tmp52_ = _tmp51_;
#line 118 "../src/game-area.vala"
	_tmp53_ = animated_forever (_tmp52_);
#line 118 "../src/game-area.vala"
	_animated_unref0 (self->priv->player_dead_animation);
#line 118 "../src/game-area.vala"
	self->priv->player_dead_animation = _tmp53_;
#line 118 "../src/game-area.vala"
	_animated_unref0 (_tmp52_);
#line 122 "../src/game-area.vala"
	_tmp54_ = animated_sequence ((gint) THEME_FRAMES_ROBOT1_START, 1);
#line 122 "../src/game-area.vala"
	_tmp55_ = _tmp54_;
#line 122 "../src/game-area.vala"
	_tmp56_ = animated_limit (_tmp55_, (gint) THEME_FRAMES_NUM_ROBOT1_ANIMATIONS);
#line 122 "../src/game-area.vala"
	_tmp57_ = _tmp56_;
#line 122 "../src/game-area.vala"
	_tmp58_ = animated_forever (_tmp57_);
#line 122 "../src/game-area.vala"
	_animated_unref0 (self->priv->robot1_animation);
#line 122 "../src/game-area.vala"
	self->priv->robot1_animation = _tmp58_;
#line 122 "../src/game-area.vala"
	_animated_unref0 (_tmp57_);
#line 122 "../src/game-area.vala"
	_animated_unref0 (_tmp55_);
#line 127 "../src/game-area.vala"
	_tmp59_ = animated_sequence ((gint) THEME_FRAMES_ROBOT2_START, 1);
#line 127 "../src/game-area.vala"
	_tmp60_ = _tmp59_;
#line 127 "../src/game-area.vala"
	_tmp61_ = animated_limit (_tmp60_, (gint) THEME_FRAMES_NUM_ROBOT2_ANIMATIONS);
#line 127 "../src/game-area.vala"
	_tmp62_ = _tmp61_;
#line 127 "../src/game-area.vala"
	_tmp63_ = animated_forever (_tmp62_);
#line 127 "../src/game-area.vala"
	_animated_unref0 (self->priv->robot2_animation);
#line 127 "../src/game-area.vala"
	self->priv->robot2_animation = _tmp63_;
#line 127 "../src/game-area.vala"
	_animated_unref0 (_tmp62_);
#line 127 "../src/game-area.vala"
	_animated_unref0 (_tmp60_);
#line 132 "../src/game-area.vala"
	self->priv->timer_id = g_timeout_add_full (G_PRIORITY_DEFAULT, (guint) GAME_AREA_ANIMATION_DELAY, _game_area_timer_cb_gsource_func, g_object_ref (self), g_object_unref);
#line 134 "../src/game-area.vala"
	g_signal_connect_object (game, "game-event", (GCallback) _game_area_on_game_event_game_game_event, self, 0);
#line 136 "../src/game-area.vala"
	g_signal_connect_object (properties, "changed", (GCallback) _game_area_properties_changed_cb_properties_changed, self, 0);
#line 138 "../src/game-area.vala"
	game_area_start_new_game (self);
#line 82 "../src/game-area.vala"
	_game_config_free0 (_tmp16_);
#line 82 "../src/game-area.vala"
	_g_object_unref0 (_tmp5_);
#line 82 "../src/game-area.vala"
	return self;
#line 1086 "game-area.c"
}

GameArea*
game_area_new (Game* game,
               GameConfigs* game_configs,
               Assets* assets,
               SoundPlayer* sound_player,
               Properties* properties,
               GError** error)
{
#line 82 "../src/game-area.vala"
	return game_area_construct (TYPE_GAME_AREA, game, game_configs, assets, sound_player, properties, error);
#line 1099 "game-area.c"
}

static void
game_area_tile_size (GameArea* self,
                     graphene_size_t* result)
{
	Game* _tmp0_;
	Arena* _tmp1_;
	Arena* _tmp2_;
	gint _tmp3_;
	gint _tmp4_;
	Game* _tmp5_;
	Arena* _tmp6_;
	Arena* _tmp7_;
	gint _tmp8_;
	gint _tmp9_;
	graphene_size_t _tmp10_ = {0};
#line 145 "../src/game-area.vala"
	g_return_if_fail (self != NULL);
#line 146 "../src/game-area.vala"
	_tmp0_ = self->priv->game;
#line 146 "../src/game-area.vala"
	_tmp1_ = game_get_arena (_tmp0_);
#line 146 "../src/game-area.vala"
	_tmp2_ = _tmp1_;
#line 146 "../src/game-area.vala"
	_tmp3_ = arena_get_width (_tmp2_);
#line 146 "../src/game-area.vala"
	_tmp4_ = _tmp3_;
#line 146 "../src/game-area.vala"
	_tmp5_ = self->priv->game;
#line 146 "../src/game-area.vala"
	_tmp6_ = game_get_arena (_tmp5_);
#line 146 "../src/game-area.vala"
	_tmp7_ = _tmp6_;
#line 146 "../src/game-area.vala"
	_tmp8_ = arena_get_height (_tmp7_);
#line 146 "../src/game-area.vala"
	_tmp9_ = _tmp8_;
#line 146 "../src/game-area.vala"
	memset (&_tmp10_, 0, sizeof (graphene_size_t));
#line 146 "../src/game-area.vala"
	_tmp10_.width = (gfloat) (gtk_widget_get_width ((GtkWidget*) self) / _tmp4_);
#line 146 "../src/game-area.vala"
	_tmp10_.height = (gfloat) (gtk_widget_get_height ((GtkWidget*) self) / _tmp9_);
#line 146 "../src/game-area.vala"
	*result = _tmp10_;
#line 146 "../src/game-area.vala"
	return;
#line 1149 "game-area.c"
}

static void
game_area_real_snapshot (GtkWidget* base,
                         GtkSnapshot* snapshot)
{
	GameArea * self;
	graphene_size_t tile_size = {0};
	graphene_size_t _tmp0_ = {0};
	Game* _tmp29_;
	ArenaCoords* _tmp30_;
	ArenaCoords* _tmp31_;
	Game* _tmp43_;
	GameState _tmp44_;
	GameState _tmp45_;
#line 152 "../src/game-area.vala"
	self = (GameArea*) base;
#line 152 "../src/game-area.vala"
	g_return_if_fail (snapshot != NULL);
#line 153 "../src/game-area.vala"
	game_area_tile_size (self, &_tmp0_);
#line 153 "../src/game-area.vala"
	tile_size = _tmp0_;
#line 1173 "game-area.c"
	{
		gint j = 0;
#line 155 "../src/game-area.vala"
		j = 0;
#line 1178 "game-area.c"
		{
			gboolean _tmp1_ = FALSE;
#line 155 "../src/game-area.vala"
			_tmp1_ = TRUE;
#line 155 "../src/game-area.vala"
			while (TRUE) {
#line 1185 "game-area.c"
				Game* _tmp3_;
				Arena* _tmp4_;
				Arena* _tmp5_;
				gint _tmp6_;
				gint _tmp7_;
#line 155 "../src/game-area.vala"
				if (!_tmp1_) {
#line 1193 "game-area.c"
					gint _tmp2_;
#line 155 "../src/game-area.vala"
					_tmp2_ = j;
#line 155 "../src/game-area.vala"
					j = _tmp2_ + 1;
#line 1199 "game-area.c"
				}
#line 155 "../src/game-area.vala"
				_tmp1_ = FALSE;
#line 155 "../src/game-area.vala"
				_tmp3_ = self->priv->game;
#line 155 "../src/game-area.vala"
				_tmp4_ = game_get_arena (_tmp3_);
#line 155 "../src/game-area.vala"
				_tmp5_ = _tmp4_;
#line 155 "../src/game-area.vala"
				_tmp6_ = arena_get_height (_tmp5_);
#line 155 "../src/game-area.vala"
				_tmp7_ = _tmp6_;
#line 155 "../src/game-area.vala"
				if (!(j < _tmp7_)) {
#line 155 "../src/game-area.vala"
					break;
#line 1217 "game-area.c"
				}
				{
					gint i = 0;
#line 156 "../src/game-area.vala"
					i = 0;
#line 1223 "game-area.c"
					{
						gboolean _tmp8_ = FALSE;
#line 156 "../src/game-area.vala"
						_tmp8_ = TRUE;
#line 156 "../src/game-area.vala"
						while (TRUE) {
#line 1230 "game-area.c"
							Game* _tmp10_;
							Arena* _tmp11_;
							Arena* _tmp12_;
							gint _tmp13_;
							gint _tmp14_;
							graphene_rect_t tile_rect = {0};
							graphene_size_t _tmp15_;
							graphene_size_t _tmp16_;
							graphene_point_t _tmp17_ = {0};
							graphene_size_t _tmp18_;
							graphene_rect_t _tmp19_ = {0};
							GdkRGBA _tmp20_ = {0};
							GdkRGBA color = {0};
							GdkRGBA _tmp23_;
							graphene_rect_t _tmp24_;
							Game* _tmp25_;
							Arena* _tmp26_;
							Arena* _tmp27_;
							graphene_rect_t _tmp28_;
#line 156 "../src/game-area.vala"
							if (!_tmp8_) {
#line 1252 "game-area.c"
								gint _tmp9_;
#line 156 "../src/game-area.vala"
								_tmp9_ = i;
#line 156 "../src/game-area.vala"
								i = _tmp9_ + 1;
#line 1258 "game-area.c"
							}
#line 156 "../src/game-area.vala"
							_tmp8_ = FALSE;
#line 156 "../src/game-area.vala"
							_tmp10_ = self->priv->game;
#line 156 "../src/game-area.vala"
							_tmp11_ = game_get_arena (_tmp10_);
#line 156 "../src/game-area.vala"
							_tmp12_ = _tmp11_;
#line 156 "../src/game-area.vala"
							_tmp13_ = arena_get_width (_tmp12_);
#line 156 "../src/game-area.vala"
							_tmp14_ = _tmp13_;
#line 156 "../src/game-area.vala"
							if (!(i < _tmp14_)) {
#line 156 "../src/game-area.vala"
								break;
#line 1276 "game-area.c"
							}
#line 157 "../src/game-area.vala"
							_tmp15_ = tile_size;
#line 157 "../src/game-area.vala"
							_tmp16_ = tile_size;
#line 157 "../src/game-area.vala"
							memset (&_tmp17_, 0, sizeof (graphene_point_t));
#line 157 "../src/game-area.vala"
							_tmp17_.x = i * _tmp15_.width;
#line 157 "../src/game-area.vala"
							_tmp17_.y = j * _tmp16_.height;
#line 157 "../src/game-area.vala"
							_tmp18_ = tile_size;
#line 157 "../src/game-area.vala"
							memset (&_tmp19_, 0, sizeof (graphene_rect_t));
#line 157 "../src/game-area.vala"
							_tmp19_.origin = _tmp17_;
#line 157 "../src/game-area.vala"
							_tmp19_.size = _tmp18_;
#line 157 "../src/game-area.vala"
							tile_rect = _tmp19_;
#line 165 "../src/game-area.vala"
							if (((i + j) % 2) != 0) {
#line 1300 "game-area.c"
								GdkRGBA _tmp21_;
#line 165 "../src/game-area.vala"
								_tmp21_ = self->priv->dark_background;
#line 165 "../src/game-area.vala"
								_tmp20_ = _tmp21_;
#line 1306 "game-area.c"
							} else {
								GdkRGBA _tmp22_;
#line 165 "../src/game-area.vala"
								_tmp22_ = self->priv->light_background;
#line 165 "../src/game-area.vala"
								_tmp20_ = _tmp22_;
#line 1313 "game-area.c"
							}
#line 165 "../src/game-area.vala"
							color = _tmp20_;
#line 166 "../src/game-area.vala"
							_tmp23_ = color;
#line 166 "../src/game-area.vala"
							_tmp24_ = tile_rect;
#line 166 "../src/game-area.vala"
							gtk_snapshot_append_color (snapshot, &_tmp23_, &_tmp24_);
#line 168 "../src/game-area.vala"
							_tmp25_ = self->priv->game;
#line 168 "../src/game-area.vala"
							_tmp26_ = game_get_arena (_tmp25_);
#line 168 "../src/game-area.vala"
							_tmp27_ = _tmp26_;
#line 168 "../src/game-area.vala"
							_tmp28_ = tile_rect;
#line 168 "../src/game-area.vala"
							game_area_draw_object (self, i, j, arena_get (_tmp27_, i, j), snapshot, &_tmp28_);
#line 1333 "game-area.c"
						}
					}
				}
			}
		}
	}
#line 172 "../src/game-area.vala"
	_tmp29_ = self->priv->game;
#line 172 "../src/game-area.vala"
	_tmp30_ = game_get_splat (_tmp29_);
#line 172 "../src/game-area.vala"
	_tmp31_ = _tmp30_;
#line 172 "../src/game-area.vala"
	if (_tmp31_ != NULL) {
#line 1348 "game-area.c"
		Assets* _tmp32_;
		Bubble* _tmp33_;
		Bubble* _tmp34_;
		Game* _tmp35_;
		ArenaCoords* _tmp36_;
		ArenaCoords* _tmp37_;
		graphene_size_t _tmp38_;
		Game* _tmp39_;
		ArenaCoords* _tmp40_;
		ArenaCoords* _tmp41_;
		graphene_size_t _tmp42_;
#line 173 "../src/game-area.vala"
		_tmp32_ = self->priv->assets;
#line 173 "../src/game-area.vala"
		_tmp33_ = assets_get_splat_bubble (_tmp32_);
#line 173 "../src/game-area.vala"
		_tmp34_ = _tmp33_;
#line 173 "../src/game-area.vala"
		_tmp35_ = self->priv->game;
#line 173 "../src/game-area.vala"
		_tmp36_ = game_get_splat (_tmp35_);
#line 173 "../src/game-area.vala"
		_tmp37_ = _tmp36_;
#line 173 "../src/game-area.vala"
		_tmp38_ = tile_size;
#line 173 "../src/game-area.vala"
		_tmp39_ = self->priv->game;
#line 173 "../src/game-area.vala"
		_tmp40_ = game_get_splat (_tmp39_);
#line 173 "../src/game-area.vala"
		_tmp41_ = _tmp40_;
#line 173 "../src/game-area.vala"
		_tmp42_ = tile_size;
#line 173 "../src/game-area.vala"
		bubble_draw (_tmp34_, snapshot, ((*_tmp37_).x * _tmp38_.width) + 8, ((*_tmp41_).y * _tmp42_.height) + 8);
#line 1384 "game-area.c"
	}
#line 178 "../src/game-area.vala"
	_tmp43_ = self->priv->game;
#line 178 "../src/game-area.vala"
	_tmp44_ = game_get_state (_tmp43_);
#line 178 "../src/game-area.vala"
	_tmp45_ = _tmp44_;
#line 178 "../src/game-area.vala"
	switch (_tmp45_) {
#line 178 "../src/game-area.vala"
		case GAME_STATE_DEAD:
#line 1396 "game-area.c"
		{
			Assets* _tmp46_;
			Bubble* _tmp47_;
			Bubble* _tmp48_;
			Game* _tmp49_;
			ArenaCoords _tmp50_ = {0};
			ArenaCoords _tmp51_;
			graphene_size_t _tmp52_;
			Game* _tmp53_;
			ArenaCoords _tmp54_ = {0};
			ArenaCoords _tmp55_;
			graphene_size_t _tmp56_;
#line 180 "../src/game-area.vala"
			_tmp46_ = self->priv->assets;
#line 180 "../src/game-area.vala"
			_tmp47_ = assets_get_aieee_bubble (_tmp46_);
#line 180 "../src/game-area.vala"
			_tmp48_ = _tmp47_;
#line 180 "../src/game-area.vala"
			_tmp49_ = self->priv->game;
#line 180 "../src/game-area.vala"
			game_get_player (_tmp49_, &_tmp50_);
#line 180 "../src/game-area.vala"
			_tmp51_ = _tmp50_;
#line 180 "../src/game-area.vala"
			_tmp52_ = tile_size;
#line 180 "../src/game-area.vala"
			_tmp53_ = self->priv->game;
#line 180 "../src/game-area.vala"
			game_get_player (_tmp53_, &_tmp54_);
#line 180 "../src/game-area.vala"
			_tmp55_ = _tmp54_;
#line 180 "../src/game-area.vala"
			_tmp56_ = tile_size;
#line 180 "../src/game-area.vala"
			bubble_draw (_tmp48_, snapshot, (_tmp51_.x * _tmp52_.width) + 8, (_tmp55_.y * _tmp56_.height) + 4);
#line 183 "../src/game-area.vala"
			break;
#line 1435 "game-area.c"
		}
#line 178 "../src/game-area.vala"
		case GAME_STATE_COMPLETE:
#line 1439 "game-area.c"
		{
			Assets* _tmp57_;
			Bubble* _tmp58_;
			Bubble* _tmp59_;
			Game* _tmp60_;
			ArenaCoords _tmp61_ = {0};
			ArenaCoords _tmp62_;
			graphene_size_t _tmp63_;
			Game* _tmp64_;
			ArenaCoords _tmp65_ = {0};
			ArenaCoords _tmp66_;
			graphene_size_t _tmp67_;
#line 185 "../src/game-area.vala"
			_tmp57_ = self->priv->assets;
#line 185 "../src/game-area.vala"
			_tmp58_ = assets_get_yahoo_bubble (_tmp57_);
#line 185 "../src/game-area.vala"
			_tmp59_ = _tmp58_;
#line 185 "../src/game-area.vala"
			_tmp60_ = self->priv->game;
#line 185 "../src/game-area.vala"
			game_get_player (_tmp60_, &_tmp61_);
#line 185 "../src/game-area.vala"
			_tmp62_ = _tmp61_;
#line 185 "../src/game-area.vala"
			_tmp63_ = tile_size;
#line 185 "../src/game-area.vala"
			_tmp64_ = self->priv->game;
#line 185 "../src/game-area.vala"
			game_get_player (_tmp64_, &_tmp65_);
#line 185 "../src/game-area.vala"
			_tmp66_ = _tmp65_;
#line 185 "../src/game-area.vala"
			_tmp67_ = tile_size;
#line 185 "../src/game-area.vala"
			bubble_draw (_tmp59_, snapshot, (_tmp62_.x * _tmp63_.width) + 8, (_tmp66_.y * _tmp67_.height) + 4);
#line 188 "../src/game-area.vala"
			break;
#line 1478 "game-area.c"
		}
		default:
		{
#line 190 "../src/game-area.vala"
			break;
#line 1484 "game-area.c"
		}
	}
}

static void
game_area_draw_object (GameArea* self,
                       gint x,
                       gint y,
                       ObjectType type,
                       GtkSnapshot* snapshot,
                       graphene_rect_t* tile_rect)
{
	gint animation = 0;
	Theme* _tmp0_;
	Theme* _tmp1_;
	graphene_rect_t _tmp2_;
#line 194 "../src/game-area.vala"
	g_return_if_fail (self != NULL);
#line 194 "../src/game-area.vala"
	g_return_if_fail (snapshot != NULL);
#line 194 "../src/game-area.vala"
	g_return_if_fail (tile_rect != NULL);
#line 195 "../src/game-area.vala"
	animation = game_area_object_animation_frame (self, type);
#line 196 "../src/game-area.vala"
	_tmp0_ = game_area_get_theme (self);
#line 196 "../src/game-area.vala"
	_tmp1_ = _tmp0_;
#line 196 "../src/game-area.vala"
	_tmp2_ = *tile_rect;
#line 196 "../src/game-area.vala"
	theme_draw_object (_tmp1_, type, animation, snapshot, &_tmp2_);
#line 1517 "game-area.c"
}

static gint
game_area_object_animation_frame (GameArea* self,
                                  ObjectType type)
{
	gint result;
#line 199 "../src/game-area.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 200 "../src/game-area.vala"
	switch (type) {
#line 200 "../src/game-area.vala"
		case OBJECT_TYPE_PLAYER:
#line 1531 "game-area.c"
		{
			Game* _tmp0_;
			GameState _tmp1_;
			GameState _tmp2_;
#line 202 "../src/game-area.vala"
			_tmp0_ = self->priv->game;
#line 202 "../src/game-area.vala"
			_tmp1_ = game_get_state (_tmp0_);
#line 202 "../src/game-area.vala"
			_tmp2_ = _tmp1_;
#line 202 "../src/game-area.vala"
			if (_tmp2_ != GAME_STATE_DEAD) {
#line 1544 "game-area.c"
				Animated* _tmp3_;
				gint _tmp4_;
				gint _tmp5_;
#line 203 "../src/game-area.vala"
				_tmp3_ = self->priv->player_animation;
#line 203 "../src/game-area.vala"
				_tmp4_ = animated_get_frame (_tmp3_);
#line 203 "../src/game-area.vala"
				_tmp5_ = _tmp4_;
#line 203 "../src/game-area.vala"
				result = _tmp5_;
#line 203 "../src/game-area.vala"
				return result;
#line 1558 "game-area.c"
			} else {
				Animated* _tmp6_;
				gint _tmp7_;
				gint _tmp8_;
#line 205 "../src/game-area.vala"
				_tmp6_ = self->priv->player_dead_animation;
#line 205 "../src/game-area.vala"
				_tmp7_ = animated_get_frame (_tmp6_);
#line 205 "../src/game-area.vala"
				_tmp8_ = _tmp7_;
#line 205 "../src/game-area.vala"
				result = _tmp8_;
#line 205 "../src/game-area.vala"
				return result;
#line 1573 "game-area.c"
			}
		}
#line 200 "../src/game-area.vala"
		case OBJECT_TYPE_ROBOT1:
#line 1578 "game-area.c"
		{
			Animated* _tmp9_;
			gint _tmp10_;
			gint _tmp11_;
#line 208 "../src/game-area.vala"
			_tmp9_ = self->priv->robot1_animation;
#line 208 "../src/game-area.vala"
			_tmp10_ = animated_get_frame (_tmp9_);
#line 208 "../src/game-area.vala"
			_tmp11_ = _tmp10_;
#line 208 "../src/game-area.vala"
			result = _tmp11_;
#line 208 "../src/game-area.vala"
			return result;
#line 1593 "game-area.c"
		}
#line 200 "../src/game-area.vala"
		case OBJECT_TYPE_ROBOT2:
#line 1597 "game-area.c"
		{
			Animated* _tmp12_;
			gint _tmp13_;
			gint _tmp14_;
#line 210 "../src/game-area.vala"
			_tmp12_ = self->priv->robot2_animation;
#line 210 "../src/game-area.vala"
			_tmp13_ = animated_get_frame (_tmp12_);
#line 210 "../src/game-area.vala"
			_tmp14_ = _tmp13_;
#line 210 "../src/game-area.vala"
			result = _tmp14_;
#line 210 "../src/game-area.vala"
			return result;
#line 1612 "game-area.c"
		}
#line 200 "../src/game-area.vala"
		case OBJECT_TYPE_HEAP:
#line 1616 "game-area.c"
		{
#line 212 "../src/game-area.vala"
			result = 0;
#line 212 "../src/game-area.vala"
			return result;
#line 1622 "game-area.c"
		}
		default:
#line 200 "../src/game-area.vala"
		case OBJECT_TYPE_NONE:
#line 1627 "game-area.c"
		{
#line 215 "../src/game-area.vala"
			result = 0;
#line 215 "../src/game-area.vala"
			return result;
#line 1633 "game-area.c"
		}
	}
}

static gboolean
game_area_timer_cb (GameArea* self)
{
	Animated* _tmp0_;
	Animated* _tmp1_;
	Animated* _tmp2_;
	Animated* _tmp3_;
	Game* _tmp4_;
	Game* _tmp5_;
	gboolean result;
#line 219 "../src/game-area.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 220 "../src/game-area.vala"
	_tmp0_ = self->priv->player_animation;
#line 220 "../src/game-area.vala"
	animated_tick (_tmp0_);
#line 221 "../src/game-area.vala"
	_tmp1_ = self->priv->player_dead_animation;
#line 221 "../src/game-area.vala"
	animated_tick (_tmp1_);
#line 222 "../src/game-area.vala"
	_tmp2_ = self->priv->robot1_animation;
#line 222 "../src/game-area.vala"
	animated_tick (_tmp2_);
#line 223 "../src/game-area.vala"
	_tmp3_ = self->priv->robot2_animation;
#line 223 "../src/game-area.vala"
	animated_tick (_tmp3_);
#line 225 "../src/game-area.vala"
	_tmp4_ = self->priv->game;
#line 225 "../src/game-area.vala"
	game_tick (_tmp4_);
#line 227 "../src/game-area.vala"
	_tmp5_ = self->priv->game;
#line 227 "../src/game-area.vala"
	g_signal_emit (self, game_area_signals[GAME_AREA_UPDATED_SIGNAL], 0, _tmp5_);
#line 229 "../src/game-area.vala"
	gtk_widget_queue_draw ((GtkWidget*) self);
#line 230 "../src/game-area.vala"
	result = TRUE;
#line 230 "../src/game-area.vala"
	return result;
#line 1680 "game-area.c"
}

static void
game_area_mouse_cb (GameArea* self,
                    gint n_press,
                    gdouble x,
                    gdouble y)
{
	Game* _tmp0_;
	GameState _tmp1_;
	GameState _tmp2_;
	gint dx = 0;
	gint dy = 0;
	gint _tmp3_ = 0;
	gint _tmp4_ = 0;
	PlayerCommand cmd = 0;
#line 233 "../src/game-area.vala"
	g_return_if_fail (self != NULL);
#line 234 "../src/game-area.vala"
	_tmp0_ = self->priv->game;
#line 234 "../src/game-area.vala"
	_tmp1_ = game_get_state (_tmp0_);
#line 234 "../src/game-area.vala"
	_tmp2_ = _tmp1_;
#line 234 "../src/game-area.vala"
	if (_tmp2_ != GAME_STATE_PLAYING) {
#line 235 "../src/game-area.vala"
		return;
#line 1709 "game-area.c"
	}
#line 239 "../src/game-area.vala"
	game_area_get_dir (self, x, y, &_tmp3_, &_tmp4_);
#line 239 "../src/game-area.vala"
	dx = _tmp3_;
#line 239 "../src/game-area.vala"
	dy = _tmp4_;
#line 241 "../src/game-area.vala"
	cmd = player_command_from_direction (dx, dy);
#line 242 "../src/game-area.vala"
	game_area_player_command (self, cmd);
#line 1721 "game-area.c"
}

static void
game_area_move_cb (GameArea* self,
                   gdouble x,
                   gdouble y)
{
	Game* _tmp0_;
	GameState _tmp1_;
	GameState _tmp2_;
#line 245 "../src/game-area.vala"
	g_return_if_fail (self != NULL);
#line 246 "../src/game-area.vala"
	_tmp0_ = self->priv->game;
#line 246 "../src/game-area.vala"
	_tmp1_ = game_get_state (_tmp0_);
#line 246 "../src/game-area.vala"
	_tmp2_ = _tmp1_;
#line 246 "../src/game-area.vala"
	if (_tmp2_ != GAME_STATE_PLAYING) {
#line 247 "../src/game-area.vala"
		gtk_widget_set_cursor ((GtkWidget*) self, NULL);
#line 1744 "game-area.c"
	} else {
		gint dx = 0;
		gint dy = 0;
		gint _tmp3_ = 0;
		gint _tmp4_ = 0;
		gint cursor_index = 0;
		GdkCursor* cursor = NULL;
		Assets* _tmp5_;
		GArray* _tmp6_;
		GArray* _tmp7_;
		GdkCursor* _tmp8_;
		GdkCursor* _tmp9_;
		GdkCursor* _tmp10_;
#line 250 "../src/game-area.vala"
		game_area_get_dir (self, x, y, &_tmp3_, &_tmp4_);
#line 250 "../src/game-area.vala"
		dx = _tmp3_;
#line 250 "../src/game-area.vala"
		dy = _tmp4_;
#line 252 "../src/game-area.vala"
		cursor_index = ((3 * dy) + dx) + 4;
#line 253 "../src/game-area.vala"
		_tmp5_ = self->priv->assets;
#line 253 "../src/game-area.vala"
		_tmp6_ = assets_get_cursors (_tmp5_);
#line 253 "../src/game-area.vala"
		_tmp7_ = _tmp6_;
#line 253 "../src/game-area.vala"
		_tmp8_ = g_array_index (_tmp7_, GdkCursor*, (guint) cursor_index);
#line 253 "../src/game-area.vala"
		_tmp9_ = _g_object_ref0 (_tmp8_);
#line 253 "../src/game-area.vala"
		cursor = _tmp9_;
#line 254 "../src/game-area.vala"
		_tmp10_ = cursor;
#line 254 "../src/game-area.vala"
		gtk_widget_set_cursor ((GtkWidget*) self, _tmp10_);
#line 246 "../src/game-area.vala"
		_g_object_unref0 (cursor);
#line 1784 "game-area.c"
	}
}

static void
game_area_get_dir (GameArea* self,
                   gdouble ix,
                   gdouble iy,
                   gint* odx,
                   gint* ody)
{
	gint _vala_odx = 0;
	gint _vala_ody = 0;
#line 259 "../src/game-area.vala"
	static const gint MOVE_TABLE[8][2] = {{-1, 0}, {-1, -1}, {0, -1}, {1, -1}, {1, 0}, {1, 1}, {0, 1}, {-1, 1}};
#line 1799 "game-area.c"
	graphene_size_t tile_size = {0};
	graphene_size_t _tmp0_ = {0};
	gint x = 0;
	graphene_size_t _tmp1_;
	Game* _tmp2_;
	Arena* _tmp3_;
	Arena* _tmp4_;
	gint _tmp5_;
	gint _tmp6_;
	gint y = 0;
	graphene_size_t _tmp7_;
	Game* _tmp8_;
	Arena* _tmp9_;
	Arena* _tmp10_;
	gint _tmp11_;
	gint _tmp12_;
	gboolean _tmp13_ = FALSE;
	Game* _tmp14_;
	ArenaCoords _tmp15_ = {0};
	ArenaCoords _tmp16_;
	gint idx = 0;
	Game* _tmp20_;
	ArenaCoords _tmp21_ = {0};
	ArenaCoords _tmp22_;
	gint idy = 0;
	Game* _tmp23_;
	ArenaCoords _tmp24_ = {0};
	ArenaCoords _tmp25_;
	gboolean _tmp26_ = FALSE;
	gdouble dx = 0.0;
	Game* _tmp27_;
	ArenaCoords _tmp28_ = {0};
	ArenaCoords _tmp29_;
	graphene_size_t _tmp30_;
	gdouble dy = 0.0;
	Game* _tmp31_;
	ArenaCoords _tmp32_ = {0};
	ArenaCoords _tmp33_;
	graphene_size_t _tmp34_;
	gdouble angle = 0.0;
	gint octant = 0;
	gint _tmp35_;
	gint _tmp36_;
#line 258 "../src/game-area.vala"
	g_return_if_fail (self != NULL);
#line 263 "../src/game-area.vala"
	game_area_tile_size (self, &_tmp0_);
#line 263 "../src/game-area.vala"
	tile_size = _tmp0_;
#line 264 "../src/game-area.vala"
	_tmp1_ = tile_size;
#line 264 "../src/game-area.vala"
	_tmp2_ = self->priv->game;
#line 264 "../src/game-area.vala"
	_tmp3_ = game_get_arena (_tmp2_);
#line 264 "../src/game-area.vala"
	_tmp4_ = _tmp3_;
#line 264 "../src/game-area.vala"
	_tmp5_ = arena_get_width (_tmp4_);
#line 264 "../src/game-area.vala"
	_tmp6_ = _tmp5_;
#line 264 "../src/game-area.vala"
	x = CLAMP ((gint) (ix / _tmp1_.width), 0, _tmp6_);
#line 265 "../src/game-area.vala"
	_tmp7_ = tile_size;
#line 265 "../src/game-area.vala"
	_tmp8_ = self->priv->game;
#line 265 "../src/game-area.vala"
	_tmp9_ = game_get_arena (_tmp8_);
#line 265 "../src/game-area.vala"
	_tmp10_ = _tmp9_;
#line 265 "../src/game-area.vala"
	_tmp11_ = arena_get_height (_tmp10_);
#line 265 "../src/game-area.vala"
	_tmp12_ = _tmp11_;
#line 265 "../src/game-area.vala"
	y = CLAMP ((gint) (iy / _tmp7_.height), 0, _tmp12_);
#line 268 "../src/game-area.vala"
	_tmp14_ = self->priv->game;
#line 268 "../src/game-area.vala"
	game_get_player (_tmp14_, &_tmp15_);
#line 268 "../src/game-area.vala"
	_tmp16_ = _tmp15_;
#line 268 "../src/game-area.vala"
	if (x == _tmp16_.x) {
#line 1885 "game-area.c"
		Game* _tmp17_;
		ArenaCoords _tmp18_ = {0};
		ArenaCoords _tmp19_;
#line 268 "../src/game-area.vala"
		_tmp17_ = self->priv->game;
#line 268 "../src/game-area.vala"
		game_get_player (_tmp17_, &_tmp18_);
#line 268 "../src/game-area.vala"
		_tmp19_ = _tmp18_;
#line 268 "../src/game-area.vala"
		_tmp13_ = y == _tmp19_.y;
#line 1897 "game-area.c"
	} else {
#line 268 "../src/game-area.vala"
		_tmp13_ = FALSE;
#line 1901 "game-area.c"
	}
#line 268 "../src/game-area.vala"
	if (_tmp13_) {
#line 269 "../src/game-area.vala"
		_vala_odx = 0;
#line 270 "../src/game-area.vala"
		_vala_ody = 0;
#line 271 "../src/game-area.vala"
		if (odx) {
#line 271 "../src/game-area.vala"
			*odx = _vala_odx;
#line 1913 "game-area.c"
		}
#line 271 "../src/game-area.vala"
		if (ody) {
#line 271 "../src/game-area.vala"
			*ody = _vala_ody;
#line 1919 "game-area.c"
		}
#line 271 "../src/game-area.vala"
		return;
#line 1923 "game-area.c"
	}
#line 275 "../src/game-area.vala"
	_tmp20_ = self->priv->game;
#line 275 "../src/game-area.vala"
	game_get_player (_tmp20_, &_tmp21_);
#line 275 "../src/game-area.vala"
	_tmp22_ = _tmp21_;
#line 275 "../src/game-area.vala"
	idx = x - _tmp22_.x;
#line 276 "../src/game-area.vala"
	_tmp23_ = self->priv->game;
#line 276 "../src/game-area.vala"
	game_get_player (_tmp23_, &_tmp24_);
#line 276 "../src/game-area.vala"
	_tmp25_ = _tmp24_;
#line 276 "../src/game-area.vala"
	idy = y - _tmp25_.y;
#line 277 "../src/game-area.vala"
	if (abs (idx) < 2) {
#line 277 "../src/game-area.vala"
		_tmp26_ = abs (idy) < 2;
#line 1945 "game-area.c"
	} else {
#line 277 "../src/game-area.vala"
		_tmp26_ = FALSE;
#line 1949 "game-area.c"
	}
#line 277 "../src/game-area.vala"
	if (_tmp26_) {
#line 278 "../src/game-area.vala"
		_vala_odx = idx;
#line 279 "../src/game-area.vala"
		_vala_ody = idy;
#line 280 "../src/game-area.vala"
		if (odx) {
#line 280 "../src/game-area.vala"
			*odx = _vala_odx;
#line 1961 "game-area.c"
		}
#line 280 "../src/game-area.vala"
		if (ody) {
#line 280 "../src/game-area.vala"
			*ody = _vala_ody;
#line 1967 "game-area.c"
		}
#line 280 "../src/game-area.vala"
		return;
#line 1971 "game-area.c"
	}
#line 284 "../src/game-area.vala"
	_tmp27_ = self->priv->game;
#line 284 "../src/game-area.vala"
	game_get_player (_tmp27_, &_tmp28_);
#line 284 "../src/game-area.vala"
	_tmp29_ = _tmp28_;
#line 284 "../src/game-area.vala"
	_tmp30_ = tile_size;
#line 284 "../src/game-area.vala"
	dx = ix - ((_tmp29_.x + 0.5) * _tmp30_.width);
#line 285 "../src/game-area.vala"
	_tmp31_ = self->priv->game;
#line 285 "../src/game-area.vala"
	game_get_player (_tmp31_, &_tmp32_);
#line 285 "../src/game-area.vala"
	_tmp33_ = _tmp32_;
#line 285 "../src/game-area.vala"
	_tmp34_ = tile_size;
#line 285 "../src/game-area.vala"
	dy = iy - ((_tmp33_.y + 0.5) * _tmp34_.height);
#line 287 "../src/game-area.vala"
	angle = atan2 (dy, dx);
#line 291 "../src/game-area.vala"
	octant = ((((gint) floor ((8.0 * angle) / G_PI)) + 9) / 2) % 8;
#line 293 "../src/game-area.vala"
	_tmp35_ = MOVE_TABLE[octant][0];
#line 293 "../src/game-area.vala"
	_vala_odx = _tmp35_;
#line 294 "../src/game-area.vala"
	_tmp36_ = MOVE_TABLE[octant][1];
#line 294 "../src/game-area.vala"
	_vala_ody = _tmp36_;
#line 258 "../src/game-area.vala"
	if (odx) {
#line 258 "../src/game-area.vala"
		*odx = _vala_odx;
#line 2009 "game-area.c"
	}
#line 258 "../src/game-area.vala"
	if (ody) {
#line 258 "../src/game-area.vala"
		*ody = _vala_ody;
#line 2015 "game-area.c"
	}
}

static void
game_area_properties_changed_cb (GameArea* self)
{
	Game* _tmp0_;
	GameConfig _tmp1_ = {0};
	GameConfig _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	Properties* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	gchar* _tmp8_;
	gboolean _tmp9_;
	Theme* _tmp19_;
	Theme* _tmp20_;
	const gchar* _tmp21_;
	const gchar* _tmp22_;
	Properties* _tmp23_;
	gchar* _tmp24_;
	gchar* _tmp25_;
	gchar* _tmp26_;
	gboolean _tmp27_;
	Properties* _tmp44_;
	GdkRGBA _tmp45_ = {0};
	GdkRGBA _tmp46_;
	GError* _inner_error0_ = NULL;
#line 297 "../src/game-area.vala"
	g_return_if_fail (self != NULL);
#line 298 "../src/game-area.vala"
	_tmp0_ = self->priv->game;
#line 298 "../src/game-area.vala"
	game_get_config (_tmp0_, &_tmp1_);
#line 298 "../src/game-area.vala"
	_tmp2_ = _tmp1_;
#line 298 "../src/game-area.vala"
	_tmp3_ = game_config_name (&_tmp2_);
#line 298 "../src/game-area.vala"
	_tmp4_ = _tmp3_;
#line 298 "../src/game-area.vala"
	_tmp5_ = self->priv->properties;
#line 298 "../src/game-area.vala"
	_tmp6_ = properties_get_selected_config (_tmp5_);
#line 298 "../src/game-area.vala"
	_tmp7_ = _tmp6_;
#line 298 "../src/game-area.vala"
	_tmp8_ = _tmp7_;
#line 298 "../src/game-area.vala"
	_tmp9_ = g_strcmp0 (_tmp4_, _tmp8_) != 0;
#line 298 "../src/game-area.vala"
	_g_free0 (_tmp8_);
#line 298 "../src/game-area.vala"
	_g_free0 (_tmp4_);
#line 298 "../src/game-area.vala"
	if (_tmp9_) {
#line 2073 "game-area.c"
		Game* _tmp10_;
		GameConfigs* _tmp11_;
		Properties* _tmp12_;
		gchar* _tmp13_;
		gchar* _tmp14_;
		gchar* _tmp15_;
		GameConfig* _tmp16_;
		GameConfig* _tmp17_;
		GameConfig _tmp18_;
#line 299 "../src/game-area.vala"
		_tmp10_ = self->priv->game;
#line 299 "../src/game-area.vala"
		_tmp11_ = self->priv->game_configs;
#line 299 "../src/game-area.vala"
		_tmp12_ = self->priv->properties;
#line 299 "../src/game-area.vala"
		_tmp13_ = properties_get_selected_config (_tmp12_);
#line 299 "../src/game-area.vala"
		_tmp14_ = _tmp13_;
#line 299 "../src/game-area.vala"
		_tmp15_ = _tmp14_;
#line 299 "../src/game-area.vala"
		_tmp16_ = game_configs_find_by_name (_tmp11_, _tmp15_);
#line 299 "../src/game-area.vala"
		_tmp17_ = _tmp16_;
#line 299 "../src/game-area.vala"
		_tmp18_ = *_tmp17_;
#line 299 "../src/game-area.vala"
		game_set_config (_tmp10_, &_tmp18_);
#line 299 "../src/game-area.vala"
		_game_config_free0 (_tmp17_);
#line 299 "../src/game-area.vala"
		_g_free0 (_tmp15_);
#line 300 "../src/game-area.vala"
		game_area_start_new_game (self);
#line 2109 "game-area.c"
	}
#line 303 "../src/game-area.vala"
	_tmp19_ = game_area_get_theme (self);
#line 303 "../src/game-area.vala"
	_tmp20_ = _tmp19_;
#line 303 "../src/game-area.vala"
	_tmp21_ = theme_get_name (_tmp20_);
#line 303 "../src/game-area.vala"
	_tmp22_ = _tmp21_;
#line 303 "../src/game-area.vala"
	_tmp23_ = self->priv->properties;
#line 303 "../src/game-area.vala"
	_tmp24_ = properties_get_theme (_tmp23_);
#line 303 "../src/game-area.vala"
	_tmp25_ = _tmp24_;
#line 303 "../src/game-area.vala"
	_tmp26_ = _tmp25_;
#line 303 "../src/game-area.vala"
	_tmp27_ = g_strcmp0 (_tmp22_, _tmp26_) != 0;
#line 303 "../src/game-area.vala"
	_g_free0 (_tmp26_);
#line 303 "../src/game-area.vala"
	if (_tmp27_) {
#line 2133 "game-area.c"
		{
			Theme* _tmp28_ = NULL;
			Assets* _tmp29_;
			GListStore* _tmp30_;
			GListStore* _tmp31_;
			Properties* _tmp32_;
			gchar* _tmp33_;
			gchar* _tmp34_;
			gchar* _tmp35_;
			Theme* _tmp36_;
			Theme* _tmp37_;
#line 305 "../src/game-area.vala"
			_tmp29_ = self->priv->assets;
#line 305 "../src/game-area.vala"
			_tmp30_ = assets_get_themes (_tmp29_);
#line 305 "../src/game-area.vala"
			_tmp31_ = _tmp30_;
#line 305 "../src/game-area.vala"
			_tmp32_ = self->priv->properties;
#line 305 "../src/game-area.vala"
			_tmp33_ = properties_get_theme (_tmp32_);
#line 305 "../src/game-area.vala"
			_tmp34_ = _tmp33_;
#line 305 "../src/game-area.vala"
			_tmp35_ = _tmp34_;
#line 305 "../src/game-area.vala"
			_tmp36_ = themes_find_best_match ((GListModel*) _tmp31_, _tmp35_, &_inner_error0_);
#line 305 "../src/game-area.vala"
			_tmp37_ = _tmp36_;
#line 305 "../src/game-area.vala"
			_g_free0 (_tmp35_);
#line 305 "../src/game-area.vala"
			_tmp28_ = _tmp37_;
#line 305 "../src/game-area.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2169 "game-area.c"
				goto __catch0_g_error;
			}
#line 305 "../src/game-area.vala"
			game_area_set_theme (self, _tmp28_);
#line 304 "../src/game-area.vala"
			_g_object_unref0 (_tmp28_);
#line 2176 "game-area.c"
		}
		goto __finally0;
		__catch0_g_error:
		{
			GError* e = NULL;
			Properties* _tmp38_;
			gchar* _tmp39_;
			gchar* _tmp40_;
			gchar* _tmp41_;
			GError* _tmp42_;
			const gchar* _tmp43_;
#line 304 "../src/game-area.vala"
			e = _inner_error0_;
#line 304 "../src/game-area.vala"
			_inner_error0_ = NULL;
#line 307 "../src/game-area.vala"
			_tmp38_ = self->priv->properties;
#line 307 "../src/game-area.vala"
			_tmp39_ = properties_get_theme (_tmp38_);
#line 307 "../src/game-area.vala"
			_tmp40_ = _tmp39_;
#line 307 "../src/game-area.vala"
			_tmp41_ = _tmp40_;
#line 307 "../src/game-area.vala"
			_tmp42_ = e;
#line 307 "../src/game-area.vala"
			_tmp43_ = _tmp42_->message;
#line 307 "../src/game-area.vala"
			g_warning ("game-area.vala:307: Cannot change theme to %s: %s", _tmp41_, _tmp43_);
#line 307 "../src/game-area.vala"
			_g_free0 (_tmp41_);
#line 304 "../src/game-area.vala"
			_g_error_free0 (e);
#line 2210 "game-area.c"
		}
		__finally0:
#line 304 "../src/game-area.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 304 "../src/game-area.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 304 "../src/game-area.vala"
			g_clear_error (&_inner_error0_);
#line 304 "../src/game-area.vala"
			return;
#line 2221 "game-area.c"
		}
	}
#line 313 "../src/game-area.vala"
	_tmp44_ = self->priv->properties;
#line 313 "../src/game-area.vala"
	properties_get_bgcolour (_tmp44_, &_tmp45_);
#line 313 "../src/game-area.vala"
	_tmp46_ = _tmp45_;
#line 313 "../src/game-area.vala"
	game_area_set_background_color (self, &_tmp46_);
#line 314 "../src/game-area.vala"
	gtk_widget_queue_draw ((GtkWidget*) self);
#line 2234 "game-area.c"
}

void
game_area_start_new_game (GameArea* self)
{
	Game* _tmp0_;
#line 317 "../src/game-area.vala"
	g_return_if_fail (self != NULL);
#line 318 "../src/game-area.vala"
	_tmp0_ = self->priv->game;
#line 318 "../src/game-area.vala"
	game_start_new_game (_tmp0_);
#line 319 "../src/game-area.vala"
	gtk_widget_queue_draw ((GtkWidget*) self);
#line 2249 "game-area.c"
}

void
game_area_set_game_config (GameArea* self,
                           GameConfig* game_config)
{
	Game* _tmp0_;
	GameConfig _tmp1_;
#line 322 "../src/game-area.vala"
	g_return_if_fail (self != NULL);
#line 322 "../src/game-area.vala"
	g_return_if_fail (game_config != NULL);
#line 323 "../src/game-area.vala"
	_tmp0_ = self->priv->game;
#line 323 "../src/game-area.vala"
	_tmp1_ = *game_config;
#line 323 "../src/game-area.vala"
	game_set_config (_tmp0_, &_tmp1_);
#line 324 "../src/game-area.vala"
	game_area_start_new_game (self);
#line 2270 "game-area.c"
}

void
game_area_player_command (GameArea* self,
                          PlayerCommand cmd)
{
	GameMoveSafety _tmp0_ = 0;
	Properties* _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp3_;
	GameMoveSafety safety = 0;
	Game* _tmp8_;
#line 327 "../src/game-area.vala"
	g_return_if_fail (self != NULL);
#line 329 "../src/game-area.vala"
	_tmp1_ = self->priv->properties;
#line 329 "../src/game-area.vala"
	_tmp2_ = properties_get_safe_moves (_tmp1_);
#line 329 "../src/game-area.vala"
	_tmp3_ = _tmp2_;
#line 329 "../src/game-area.vala"
	if (!_tmp3_) {
#line 329 "../src/game-area.vala"
		_tmp0_ = GAME_MOVE_SAFETY_UNSAFE;
#line 2295 "game-area.c"
	} else {
		GameMoveSafety _tmp4_ = 0;
		Properties* _tmp5_;
		gboolean _tmp6_;
		gboolean _tmp7_;
#line 330 "../src/game-area.vala"
		_tmp5_ = self->priv->properties;
#line 330 "../src/game-area.vala"
		_tmp6_ = properties_get_super_safe_moves (_tmp5_);
#line 330 "../src/game-area.vala"
		_tmp7_ = _tmp6_;
#line 330 "../src/game-area.vala"
		if (_tmp7_) {
#line 330 "../src/game-area.vala"
			_tmp4_ = GAME_MOVE_SAFETY_SUPER_SAFE;
#line 2311 "game-area.c"
		} else {
#line 331 "../src/game-area.vala"
			_tmp4_ = GAME_MOVE_SAFETY_SAFE;
#line 2315 "game-area.c"
		}
#line 330 "../src/game-area.vala"
		_tmp0_ = _tmp4_;
#line 2319 "game-area.c"
	}
#line 328 "../src/game-area.vala"
	safety = _tmp0_;
#line 333 "../src/game-area.vala"
	_tmp8_ = self->priv->game;
#line 333 "../src/game-area.vala"
	if (game_player_command (_tmp8_, cmd, safety)) {
#line 334 "../src/game-area.vala"
		gtk_widget_queue_draw ((GtkWidget*) self);
#line 2329 "game-area.c"
	} else {
#line 336 "../src/game-area.vala"
		game_area_play_sound (self, SOUND_BAD);
#line 2333 "game-area.c"
	}
}

static void
game_area_on_game_event (GameArea* self,
                         GameEvent event,
                         gint param)
{
#line 340 "../src/game-area.vala"
	g_return_if_fail (self != NULL);
#line 341 "../src/game-area.vala"
	switch (event) {
#line 341 "../src/game-area.vala"
		case GAME_EVENT_TELEPORTED:
#line 2348 "game-area.c"
		{
#line 343 "../src/game-area.vala"
			game_area_play_sound (self, SOUND_TELEPORT);
#line 344 "../src/game-area.vala"
			break;
#line 2354 "game-area.c"
		}
#line 341 "../src/game-area.vala"
		case GAME_EVENT_SPLAT:
#line 2358 "game-area.c"
		{
#line 346 "../src/game-area.vala"
			game_area_play_sound (self, SOUND_SPLAT);
#line 347 "../src/game-area.vala"
			break;
#line 2364 "game-area.c"
		}
#line 341 "../src/game-area.vala"
		case GAME_EVENT_LEVEL_COMPLETE:
#line 2368 "game-area.c"
		{
#line 349 "../src/game-area.vala"
			game_area_play_sound (self, SOUND_YAHOO);
#line 350 "../src/game-area.vala"
			break;
#line 2374 "game-area.c"
		}
#line 341 "../src/game-area.vala"
		case GAME_EVENT_DEATH:
#line 2378 "game-area.c"
		{
#line 352 "../src/game-area.vala"
			game_area_play_sound (self, SOUND_DIE);
#line 353 "../src/game-area.vala"
			break;
#line 2384 "game-area.c"
		}
#line 341 "../src/game-area.vala"
		case GAME_EVENT_SCORED:
#line 2388 "game-area.c"
		{
#line 355 "../src/game-area.vala"
			game_area_log_score (self, param);
#line 356 "../src/game-area.vala"
			break;
#line 2394 "game-area.c"
		}
#line 341 "../src/game-area.vala"
		case GAME_EVENT_VICTORY:
#line 2398 "game-area.c"
		{
#line 358 "../src/game-area.vala"
			game_area_message_box (self, _ ("Congratulations, You Have Defeated the Robots!! \n" \
"But Can You do it Again?"));
#line 359 "../src/game-area.vala"
			game_area_play_sound (self, SOUND_VICTORY);
#line 360 "../src/game-area.vala"
			break;
#line 2406 "game-area.c"
		}
#line 341 "../src/game-area.vala"
		case GAME_EVENT_NO_TELEPORT_LOCATIONS:
#line 2410 "game-area.c"
		{
#line 362 "../src/game-area.vala"
			game_area_message_box (self, _ ("There are no teleport locations left!!"));
#line 363 "../src/game-area.vala"
			break;
#line 2416 "game-area.c"
		}
#line 341 "../src/game-area.vala"
		case GAME_EVENT_NO_SAFE_TELEPORT_LOCATIONS:
#line 2420 "game-area.c"
		{
#line 365 "../src/game-area.vala"
			break;
#line 2424 "game-area.c"
		}
		default:
		{
#line 367 "../src/game-area.vala"
			break;
#line 2430 "game-area.c"
		}
	}
}

/**
     * Enters a score in the high-score table
     **/
static void
game_area_log_score (GameArea* self,
                     gint score)
{
	gchar* game_type = NULL;
	Properties* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
	const gchar* _tmp21_;
#line 374 "../src/game-area.vala"
	g_return_if_fail (self != NULL);
#line 375 "../src/game-area.vala"
	if (score <= 0) {
#line 376 "../src/game-area.vala"
		return;
#line 2453 "game-area.c"
	}
#line 380 "../src/game-area.vala"
	_tmp0_ = self->priv->properties;
#line 380 "../src/game-area.vala"
	_tmp1_ = properties_get_super_safe_moves (_tmp0_);
#line 380 "../src/game-area.vala"
	_tmp2_ = _tmp1_;
#line 380 "../src/game-area.vala"
	if (_tmp2_) {
#line 2463 "game-area.c"
		Game* _tmp3_;
		GameConfig _tmp4_ = {0};
		GameConfig _tmp5_;
		const gchar* _tmp6_;
		gchar* _tmp7_;
#line 381 "../src/game-area.vala"
		_tmp3_ = self->priv->game;
#line 381 "../src/game-area.vala"
		game_get_config (_tmp3_, &_tmp4_);
#line 381 "../src/game-area.vala"
		_tmp5_ = _tmp4_;
#line 381 "../src/game-area.vala"
		_tmp6_ = _tmp5_.description;
#line 381 "../src/game-area.vala"
		_tmp7_ = g_strconcat (_tmp6_, "-super-safe", NULL);
#line 381 "../src/game-area.vala"
		_g_free0 (game_type);
#line 381 "../src/game-area.vala"
		game_type = _tmp7_;
#line 2483 "game-area.c"
	} else {
		Properties* _tmp8_;
		gboolean _tmp9_;
		gboolean _tmp10_;
#line 382 "../src/game-area.vala"
		_tmp8_ = self->priv->properties;
#line 382 "../src/game-area.vala"
		_tmp9_ = properties_get_safe_moves (_tmp8_);
#line 382 "../src/game-area.vala"
		_tmp10_ = _tmp9_;
#line 382 "../src/game-area.vala"
		if (_tmp10_) {
#line 2496 "game-area.c"
			Game* _tmp11_;
			GameConfig _tmp12_ = {0};
			GameConfig _tmp13_;
			const gchar* _tmp14_;
			gchar* _tmp15_;
#line 383 "../src/game-area.vala"
			_tmp11_ = self->priv->game;
#line 383 "../src/game-area.vala"
			game_get_config (_tmp11_, &_tmp12_);
#line 383 "../src/game-area.vala"
			_tmp13_ = _tmp12_;
#line 383 "../src/game-area.vala"
			_tmp14_ = _tmp13_.description;
#line 383 "../src/game-area.vala"
			_tmp15_ = g_strconcat (_tmp14_, "-safe", NULL);
#line 383 "../src/game-area.vala"
			_g_free0 (game_type);
#line 383 "../src/game-area.vala"
			game_type = _tmp15_;
#line 2516 "game-area.c"
		} else {
			Game* _tmp16_;
			GameConfig _tmp17_ = {0};
			GameConfig _tmp18_;
			const gchar* _tmp19_;
			gchar* _tmp20_;
#line 385 "../src/game-area.vala"
			_tmp16_ = self->priv->game;
#line 385 "../src/game-area.vala"
			game_get_config (_tmp16_, &_tmp17_);
#line 385 "../src/game-area.vala"
			_tmp18_ = _tmp17_;
#line 385 "../src/game-area.vala"
			_tmp19_ = _tmp18_.description;
#line 385 "../src/game-area.vala"
			_tmp20_ = g_strdup (_tmp19_);
#line 385 "../src/game-area.vala"
			_g_free0 (game_type);
#line 385 "../src/game-area.vala"
			game_type = _tmp20_;
#line 2537 "game-area.c"
		}
	}
#line 388 "../src/game-area.vala"
	_tmp21_ = game_type;
#line 388 "../src/game-area.vala"
	g_signal_emit (self, game_area_signals[GAME_AREA_ADD_SCORE_SIGNAL], 0, _tmp21_, score);
#line 374 "../src/game-area.vala"
	_g_free0 (game_type);
#line 2546 "game-area.c"
}

static void
game_area_play_sound (GameArea* self,
                      Sound sound)
{
	Properties* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
#line 391 "../src/game-area.vala"
	g_return_if_fail (self != NULL);
#line 392 "../src/game-area.vala"
	_tmp0_ = self->priv->properties;
#line 392 "../src/game-area.vala"
	_tmp1_ = properties_get_sound (_tmp0_);
#line 392 "../src/game-area.vala"
	_tmp2_ = _tmp1_;
#line 392 "../src/game-area.vala"
	if (_tmp2_) {
#line 2566 "game-area.c"
		SoundPlayer* _tmp3_;
#line 393 "../src/game-area.vala"
		_tmp3_ = self->priv->sound_player;
#line 393 "../src/game-area.vala"
		sound_player_play (_tmp3_, sound);
#line 2572 "game-area.c"
	}
}

/**
     * Displays a modal dialog box with a given message
     **/
static void
game_area_message_box (GameArea* self,
                       const gchar* msg)
{
	GtkWindow* window = NULL;
	GtkRoot* _tmp0_;
	GtkWindow* _tmp1_;
	GtkWindow* _tmp2_;
#line 400 "../src/game-area.vala"
	g_return_if_fail (self != NULL);
#line 400 "../src/game-area.vala"
	g_return_if_fail (msg != NULL);
#line 401 "../src/game-area.vala"
	_tmp0_ = gtk_widget_get_root ((GtkWidget*) self);
#line 401 "../src/game-area.vala"
	_tmp1_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp0_, gtk_window_get_type ()) ? ((GtkWindow*) _tmp0_) : NULL);
#line 401 "../src/game-area.vala"
	window = _tmp1_;
#line 402 "../src/game-area.vala"
	_tmp2_ = window;
#line 402 "../src/game-area.vala"
	if (_tmp2_ != NULL) {
#line 2601 "game-area.c"
		GtkAlertDialog* dialog = NULL;
		GtkAlertDialog* _tmp3_;
		GtkAlertDialog* _tmp4_;
		GtkWindow* _tmp5_;
#line 403 "../src/game-area.vala"
		_tmp3_ = gtk_alert_dialog_new ("%s", msg);
#line 403 "../src/game-area.vala"
		dialog = _tmp3_;
#line 404 "../src/game-area.vala"
		_tmp4_ = dialog;
#line 404 "../src/game-area.vala"
		_tmp5_ = window;
#line 404 "../src/game-area.vala"
		gtk_alert_dialog_show (_tmp4_, _tmp5_);
#line 402 "../src/game-area.vala"
		_g_object_unref0 (dialog);
#line 2618 "game-area.c"
	} else {
#line 406 "../src/game-area.vala"
		g_warning ("game-area.vala:406: There is no top level window.");
#line 407 "../src/game-area.vala"
		g_info ("game-area.vala:407: %s", msg);
#line 2624 "game-area.c"
	}
#line 400 "../src/game-area.vala"
	_g_object_unref0 (window);
#line 2628 "game-area.c"
}

Theme*
game_area_get_theme (GameArea* self)
{
	Theme* result;
	Theme* _tmp0_;
#line 46 "../src/game-area.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 47 "../src/game-area.vala"
	_tmp0_ = self->priv->_theme;
#line 47 "../src/game-area.vala"
	result = _tmp0_;
#line 47 "../src/game-area.vala"
	return result;
#line 2644 "game-area.c"
}

void
game_area_set_theme (GameArea* self,
                     Theme* value)
{
	Theme* _tmp0_;
#line 49 "../src/game-area.vala"
	g_return_if_fail (self != NULL);
#line 50 "../src/game-area.vala"
	_tmp0_ = _g_object_ref0 (value);
#line 50 "../src/game-area.vala"
	_g_object_unref0 (self->priv->_theme);
#line 50 "../src/game-area.vala"
	self->priv->_theme = _tmp0_;
#line 51 "../src/game-area.vala"
	gtk_widget_queue_draw ((GtkWidget*) self);
#line 49 "../src/game-area.vala"
	g_object_notify_by_pspec ((GObject *) self, game_area_properties[GAME_AREA_THEME_PROPERTY]);
#line 2664 "game-area.c"
}

void
game_area_get_background_color (GameArea* self,
                                GdkRGBA * result)
{
	GdkRGBA _tmp0_;
#line 56 "../src/game-area.vala"
	g_return_if_fail (self != NULL);
#line 56 "../src/game-area.vala"
	_tmp0_ = self->priv->dark_background;
#line 56 "../src/game-area.vala"
	*result = _tmp0_;
#line 56 "../src/game-area.vala"
	return;
#line 2680 "game-area.c"
}

void
game_area_set_background_color (GameArea* self,
                                GdkRGBA * value)
{
	GdkRGBA _tmp0_;
	GdkRGBA _tmp1_;
	GdkRGBA _tmp2_ = {0};
#line 57 "../src/game-area.vala"
	g_return_if_fail (self != NULL);
#line 58 "../src/game-area.vala"
	_tmp0_ = *value;
#line 58 "../src/game-area.vala"
	self->priv->dark_background = _tmp0_;
#line 59 "../src/game-area.vala"
	_tmp1_ = *value;
#line 59 "../src/game-area.vala"
	calculate_light_color (&_tmp1_, &_tmp2_);
#line 59 "../src/game-area.vala"
	self->priv->light_background = _tmp2_;
#line 60 "../src/game-area.vala"
	gtk_widget_queue_draw ((GtkWidget*) self);
#line 57 "../src/game-area.vala"
	g_object_notify_by_pspec ((GObject *) self, game_area_properties[GAME_AREA_BACKGROUND_COLOR_PROPERTY]);
#line 2706 "game-area.c"
}

gchar*
game_area_get_background_color_name (GameArea* self)
{
	gchar* result;
	GdkRGBA _tmp0_;
	gchar* _tmp1_;
#line 65 "../src/game-area.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 66 "../src/game-area.vala"
	_tmp0_ = self->priv->dark_background;
#line 66 "../src/game-area.vala"
	_tmp1_ = rgba_to_string (&_tmp0_);
#line 66 "../src/game-area.vala"
	result = _tmp1_;
#line 66 "../src/game-area.vala"
	return result;
#line 2725 "game-area.c"
}

void
game_area_set_background_color_name (GameArea* self,
                                     const gchar* value)
{
	GdkRGBA color = {0};
	const gchar* _tmp0_;
	const gchar* _tmp1_;
#line 68 "../src/game-area.vala"
	g_return_if_fail (self != NULL);
#line 69 "../src/game-area.vala"
	memset (&color, 0, sizeof (GdkRGBA));
#line 70 "../src/game-area.vala"
	_tmp0_ = gtk_widget_get_name ((GtkWidget*) self);
#line 70 "../src/game-area.vala"
	_tmp1_ = _tmp0_;
#line 70 "../src/game-area.vala"
	if (gdk_rgba_parse (&color, _tmp1_)) {
#line 2745 "game-area.c"
		GdkRGBA _tmp2_;
#line 71 "../src/game-area.vala"
		_tmp2_ = color;
#line 71 "../src/game-area.vala"
		game_area_set_background_color (self, &_tmp2_);
#line 2751 "game-area.c"
	}
#line 68 "../src/game-area.vala"
	g_object_notify_by_pspec ((GObject *) self, game_area_properties[GAME_AREA_BACKGROUND_COLOR_NAME_PROPERTY]);
#line 2755 "game-area.c"
}

static void
g_cclosure_user_marshal_VOID__GAME (GClosure * closure,
                                    GValue * return_value,
                                    guint n_param_values,
                                    const GValue * param_values,
                                    gpointer invocation_hint,
                                    gpointer marshal_data)
{
	typedef void (*GMarshalFunc_VOID__GAME) (gpointer data1, gpointer arg_1, gpointer data2);
	register GMarshalFunc_VOID__GAME callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
#line 24 "../src/game-area.vala"
	g_return_if_fail (n_param_values == 2);
#line 24 "../src/game-area.vala"
	if (G_CCLOSURE_SWAP_DATA (closure)) {
#line 24 "../src/game-area.vala"
		data1 = closure->data;
#line 24 "../src/game-area.vala"
		data2 = param_values->data[0].v_pointer;
#line 2780 "game-area.c"
	} else {
#line 24 "../src/game-area.vala"
		data1 = param_values->data[0].v_pointer;
#line 24 "../src/game-area.vala"
		data2 = closure->data;
#line 2786 "game-area.c"
	}
#line 24 "../src/game-area.vala"
	callback = (GMarshalFunc_VOID__GAME) (marshal_data ? marshal_data : cc->callback);
#line 24 "../src/game-area.vala"
	callback (data1, value_get_game (param_values + 1), data2);
#line 2792 "game-area.c"
}

static void
g_cclosure_user_marshal_VOID__STRING_INT (GClosure * closure,
                                          GValue * return_value,
                                          guint n_param_values,
                                          const GValue * param_values,
                                          gpointer invocation_hint,
                                          gpointer marshal_data)
{
	typedef void (*GMarshalFunc_VOID__STRING_INT) (gpointer data1, const char* arg_1, gint arg_2, gpointer data2);
	register GMarshalFunc_VOID__STRING_INT callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
#line 24 "../src/game-area.vala"
	g_return_if_fail (n_param_values == 3);
#line 24 "../src/game-area.vala"
	if (G_CCLOSURE_SWAP_DATA (closure)) {
#line 24 "../src/game-area.vala"
		data1 = closure->data;
#line 24 "../src/game-area.vala"
		data2 = param_values->data[0].v_pointer;
#line 2817 "game-area.c"
	} else {
#line 24 "../src/game-area.vala"
		data1 = param_values->data[0].v_pointer;
#line 24 "../src/game-area.vala"
		data2 = closure->data;
#line 2823 "game-area.c"
	}
#line 24 "../src/game-area.vala"
	callback = (GMarshalFunc_VOID__STRING_INT) (marshal_data ? marshal_data : cc->callback);
#line 24 "../src/game-area.vala"
	callback (data1, g_value_get_string (param_values + 1), g_value_get_int (param_values + 2), data2);
#line 2829 "game-area.c"
}

static void
game_area_class_init (GameAreaClass * klass,
                      gpointer klass_data)
{
#line 24 "../src/game-area.vala"
	game_area_parent_class = g_type_class_peek_parent (klass);
#line 24 "../src/game-area.vala"
	g_type_class_adjust_private_offset (klass, &GameArea_private_offset);
#line 24 "../src/game-area.vala"
	((GtkWidgetClass *) klass)->snapshot = (void (*) (GtkWidget*, GtkSnapshot*)) game_area_real_snapshot;
#line 24 "../src/game-area.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_game_area_get_property;
#line 24 "../src/game-area.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_game_area_set_property;
#line 24 "../src/game-area.vala"
	G_OBJECT_CLASS (klass)->finalize = game_area_finalize;
#line 24 "../src/game-area.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GAME_AREA_THEME_PROPERTY, game_area_properties[GAME_AREA_THEME_PROPERTY] = g_param_spec_object ("theme", "theme", "theme", TYPE_THEME, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 24 "../src/game-area.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GAME_AREA_BACKGROUND_COLOR_PROPERTY, game_area_properties[GAME_AREA_BACKGROUND_COLOR_PROPERTY] = g_param_spec_boxed ("background-color", "background-color", "background-color", gdk_rgba_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 24 "../src/game-area.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GAME_AREA_BACKGROUND_COLOR_NAME_PROPERTY, game_area_properties[GAME_AREA_BACKGROUND_COLOR_NAME_PROPERTY] = g_param_spec_string ("background-color-name", "background-color-name", "background-color-name", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 24 "../src/game-area.vala"
	game_area_signals[GAME_AREA_UPDATED_SIGNAL] = g_signal_new ("updated", TYPE_GAME_AREA, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__GAME, G_TYPE_NONE, 1, TYPE_GAME);
#line 24 "../src/game-area.vala"
	game_area_signals[GAME_AREA_ADD_SCORE_SIGNAL] = g_signal_new ("add-score", TYPE_GAME_AREA, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__STRING_INT, G_TYPE_NONE, 2, G_TYPE_STRING, G_TYPE_INT);
#line 2858 "game-area.c"
}

static void
game_area_instance_init (GameArea * self,
                         gpointer klass)
{
#line 24 "../src/game-area.vala"
	self->priv = game_area_get_instance_private (self);
#line 2867 "game-area.c"
}

static void
game_area_finalize (GObject * obj)
{
	GameArea * self;
#line 24 "../src/game-area.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_GAME_AREA, GameArea);
#line 142 "../src/game-area.vala"
	g_source_remove (self->priv->timer_id);
#line 30 "../src/game-area.vala"
	_g_object_unref0 (self->priv->click_controller);
#line 31 "../src/game-area.vala"
	_g_object_unref0 (self->priv->motion_controller);
#line 32 "../src/game-area.vala"
	_game_unref0 (self->priv->game);
#line 33 "../src/game-area.vala"
	_game_configs_unref0 (self->priv->game_configs);
#line 34 "../src/game-area.vala"
	_g_object_unref0 (self->priv->assets);
#line 35 "../src/game-area.vala"
	_g_object_unref0 (self->priv->_theme);
#line 40 "../src/game-area.vala"
	_animated_unref0 (self->priv->player_animation);
#line 41 "../src/game-area.vala"
	_animated_unref0 (self->priv->player_dead_animation);
#line 42 "../src/game-area.vala"
	_animated_unref0 (self->priv->robot1_animation);
#line 43 "../src/game-area.vala"
	_animated_unref0 (self->priv->robot2_animation);
#line 76 "../src/game-area.vala"
	_sound_player_unref0 (self->priv->sound_player);
#line 77 "../src/game-area.vala"
	_properties_unref0 (self->priv->properties);
#line 24 "../src/game-area.vala"
	G_OBJECT_CLASS (game_area_parent_class)->finalize (obj);
#line 2904 "game-area.c"
}

static GType
game_area_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (GameAreaClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) game_area_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GameArea), 0, (GInstanceInitFunc) game_area_instance_init, NULL };
	GType game_area_type_id;
	game_area_type_id = g_type_register_static (gtk_widget_get_type (), "GameArea", &g_define_type_info, 0);
	GameArea_private_offset = g_type_add_instance_private (game_area_type_id, sizeof (GameAreaPrivate));
	return game_area_type_id;
}

GType
game_area_get_type (void)
{
	static volatile gsize game_area_type_id__once = 0;
	if (g_once_init_enter (&game_area_type_id__once)) {
		GType game_area_type_id;
		game_area_type_id = game_area_get_type_once ();
		g_once_init_leave (&game_area_type_id__once, game_area_type_id);
	}
	return game_area_type_id__once;
}

static void
_vala_game_area_get_property (GObject * object,
                              guint property_id,
                              GValue * value,
                              GParamSpec * pspec)
{
	GameArea * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_GAME_AREA, GameArea);
#line 24 "../src/game-area.vala"
	switch (property_id) {
#line 24 "../src/game-area.vala"
		case GAME_AREA_THEME_PROPERTY:
#line 24 "../src/game-area.vala"
		g_value_set_object (value, game_area_get_theme (self));
#line 24 "../src/game-area.vala"
		break;
#line 24 "../src/game-area.vala"
		case GAME_AREA_BACKGROUND_COLOR_PROPERTY:
#line 2947 "game-area.c"
		{
			GdkRGBA boxed;
#line 24 "../src/game-area.vala"
			game_area_get_background_color (self, &boxed);
#line 24 "../src/game-area.vala"
			g_value_set_boxed (value, &boxed);
#line 2954 "game-area.c"
		}
#line 24 "../src/game-area.vala"
		break;
#line 24 "../src/game-area.vala"
		case GAME_AREA_BACKGROUND_COLOR_NAME_PROPERTY:
#line 24 "../src/game-area.vala"
		g_value_take_string (value, game_area_get_background_color_name (self));
#line 24 "../src/game-area.vala"
		break;
#line 2964 "game-area.c"
		default:
#line 24 "../src/game-area.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 24 "../src/game-area.vala"
		break;
#line 2970 "game-area.c"
	}
}

static void
_vala_game_area_set_property (GObject * object,
                              guint property_id,
                              const GValue * value,
                              GParamSpec * pspec)
{
	GameArea * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_GAME_AREA, GameArea);
#line 24 "../src/game-area.vala"
	switch (property_id) {
#line 24 "../src/game-area.vala"
		case GAME_AREA_THEME_PROPERTY:
#line 24 "../src/game-area.vala"
		game_area_set_theme (self, g_value_get_object (value));
#line 24 "../src/game-area.vala"
		break;
#line 24 "../src/game-area.vala"
		case GAME_AREA_BACKGROUND_COLOR_PROPERTY:
#line 24 "../src/game-area.vala"
		game_area_set_background_color (self, g_value_get_boxed (value));
#line 24 "../src/game-area.vala"
		break;
#line 24 "../src/game-area.vala"
		case GAME_AREA_BACKGROUND_COLOR_NAME_PROPERTY:
#line 24 "../src/game-area.vala"
		game_area_set_background_color_name (self, g_value_get_string (value));
#line 24 "../src/game-area.vala"
		break;
#line 3002 "game-area.c"
		default:
#line 24 "../src/game-area.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 24 "../src/game-area.vala"
		break;
#line 3008 "game-area.c"
	}
}

