/* image.c generated by valac 0.56.16, the Vala compiler
 * generated from image.vala, do not modify */

/*
 * Copyright 2022 Andrey Kutejko <andy128k@gmail.com>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, see <http://www.gnu.org/licenses/>.
 *
 * For more details see the file COPYING.
 */

#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <gdk/gdk.h>
#include <librsvg/rsvg.h>
#include <glib-object.h>
#include <gdk-pixbuf/gdk-pixbuf.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define TYPE_SVG_PAINTABLE (svg_paintable_get_type ())
#define SVG_PAINTABLE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SVG_PAINTABLE, SvgPaintable))
#define SVG_PAINTABLE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SVG_PAINTABLE, SvgPaintableClass))
#define IS_SVG_PAINTABLE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SVG_PAINTABLE))
#define IS_SVG_PAINTABLE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SVG_PAINTABLE))
#define SVG_PAINTABLE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SVG_PAINTABLE, SvgPaintableClass))

typedef struct _SvgPaintable SvgPaintable;
typedef struct _SvgPaintableClass SvgPaintableClass;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

VALA_EXTERN GdkPaintable* image_from_file (const gchar* filename,
                               GError** error);
VALA_EXTERN SvgPaintable* svg_paintable_new (RsvgHandle* rsvg_handle);
VALA_EXTERN SvgPaintable* svg_paintable_construct (GType object_type,
                                       RsvgHandle* rsvg_handle);
VALA_EXTERN GType svg_paintable_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (SvgPaintable, g_object_unref)

GdkPaintable*
image_from_file (const gchar* filename,
                 GError** error)
{
	GError* _inner_error0_ = NULL;
	GdkPaintable* result;
#line 24 "../src/image.vala"
	g_return_val_if_fail (filename != NULL, NULL);
#line 77 "image.c"
	{
		RsvgHandle* rsvg_handle = NULL;
		RsvgHandle* _tmp0_;
		RsvgHandle* _tmp1_;
		SvgPaintable* _tmp2_;
#line 26 "../src/image.vala"
		_tmp0_ = rsvg_handle_new_from_file (filename, &_inner_error0_);
#line 26 "../src/image.vala"
		rsvg_handle = _tmp0_;
#line 26 "../src/image.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 89 "image.c"
			goto __catch0_g_error;
		}
#line 27 "../src/image.vala"
		_tmp1_ = rsvg_handle;
#line 27 "../src/image.vala"
		_tmp2_ = svg_paintable_new (_tmp1_);
#line 27 "../src/image.vala"
		result = (GdkPaintable*) _tmp2_;
#line 27 "../src/image.vala"
		_g_object_unref0 (rsvg_handle);
#line 27 "../src/image.vala"
		return result;
#line 102 "image.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GdkPixbuf* pixbuf = NULL;
		GdkPixbuf* _tmp3_;
		GdkPixbuf* _tmp4_;
		GdkTexture* _tmp5_;
#line 25 "../src/image.vala"
		g_clear_error (&_inner_error0_);
#line 29 "../src/image.vala"
		_tmp3_ = gdk_pixbuf_new_from_file (filename, &_inner_error0_);
#line 29 "../src/image.vala"
		pixbuf = _tmp3_;
#line 29 "../src/image.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 119 "image.c"
			goto __finally0;
		}
#line 30 "../src/image.vala"
		_tmp4_ = pixbuf;
#line 30 "../src/image.vala"
		_tmp5_ = gdk_texture_new_for_pixbuf (_tmp4_);
#line 30 "../src/image.vala"
		result = (GdkPaintable*) _tmp5_;
#line 30 "../src/image.vala"
		_g_object_unref0 (pixbuf);
#line 30 "../src/image.vala"
		return result;
#line 132 "image.c"
	}
	__finally0:
#line 25 "../src/image.vala"
	g_propagate_error (error, _inner_error0_);
#line 25 "../src/image.vala"
	return NULL;
#line 139 "image.c"
}

