/* sound-player.c generated by valac 0.56.16, the Vala compiler
 * generated from sound-player.vala, do not modify */

/*
 * Copyright 2020-2023 Andrey Kutejko <andy128k@gmail.com>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, see <http://www.gnu.org/licenses/>.
 *
 * For more details see the file COPYING.
 */

#include <glib-object.h>
#include <gst/gst.h>
#include <glib.h>
#include <gdk/gdk.h>
#include <stdlib.h>
#include <string.h>
#include <gobject/gvaluecollector.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

typedef enum  {
	SOUND_VICTORY = 0,
	SOUND_DIE,
	SOUND_TELEPORT,
	SOUND_SPLAT,
	SOUND_YAHOO,
	SOUND_BAD
} Sound;

#define TYPE_SOUND (sound_get_type ())

#define TYPE_SOUND_PLAYER (sound_player_get_type ())
#define SOUND_PLAYER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SOUND_PLAYER, SoundPlayer))
#define SOUND_PLAYER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SOUND_PLAYER, SoundPlayerClass))
#define IS_SOUND_PLAYER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SOUND_PLAYER))
#define IS_SOUND_PLAYER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SOUND_PLAYER))
#define SOUND_PLAYER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SOUND_PLAYER, SoundPlayerClass))

typedef struct _SoundPlayer SoundPlayer;
typedef struct _SoundPlayerClass SoundPlayerClass;
typedef struct _SoundPlayerPrivate SoundPlayerPrivate;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
typedef struct _ParamSpecSoundPlayer ParamSpecSoundPlayer;

struct _SoundPlayer {
	GTypeInstance parent_instance;
	volatile int ref_count;
	SoundPlayerPrivate * priv;
};

struct _SoundPlayerClass {
	GTypeClass parent_class;
	void (*finalize) (SoundPlayer *self);
};

struct _SoundPlayerPrivate {
	GstPipeline* pipeline;
	GstElement* playbin;
};

struct _ParamSpecSoundPlayer {
	GParamSpec parent_instance;
};

static gint SoundPlayer_private_offset;
static gpointer sound_player_parent_class = NULL;

VALA_EXTERN GType sound_get_type (void) G_GNUC_CONST ;
VALA_EXTERN gpointer sound_player_ref (gpointer instance);
VALA_EXTERN void sound_player_unref (gpointer instance);
VALA_EXTERN GParamSpec* param_spec_sound_player (const gchar* name,
                                     const gchar* nick,
                                     const gchar* blurb,
                                     GType object_type,
                                     GParamFlags flags);
VALA_EXTERN void value_set_sound_player (GValue* value,
                             gpointer v_object);
VALA_EXTERN void value_take_sound_player (GValue* value,
                              gpointer v_object);
VALA_EXTERN gpointer value_get_sound_player (const GValue* value);
VALA_EXTERN GType sound_player_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (SoundPlayer, sound_player_unref)
VALA_EXTERN SoundPlayer* sound_player_new (void);
VALA_EXTERN SoundPlayer* sound_player_construct (GType object_type);
VALA_EXTERN void sound_player_beep (SoundPlayer* self);
VALA_EXTERN void sound_player_play_file (SoundPlayer* self,
                             const gchar* name);
VALA_EXTERN void sound_player_play (SoundPlayer* self,
                        Sound sound);
static void sound_player_finalize (SoundPlayer * obj);
static GType sound_player_get_type_once (void);

static GType
sound_get_type_once (void)
{
	static const GEnumValue values[] = {{SOUND_VICTORY, "SOUND_VICTORY", "victory"}, {SOUND_DIE, "SOUND_DIE", "die"}, {SOUND_TELEPORT, "SOUND_TELEPORT", "teleport"}, {SOUND_SPLAT, "SOUND_SPLAT", "splat"}, {SOUND_YAHOO, "SOUND_YAHOO", "yahoo"}, {SOUND_BAD, "SOUND_BAD", "bad"}, {0, NULL, NULL}};
	GType sound_type_id;
	sound_type_id = g_enum_register_static ("Sound", values);
	return sound_type_id;
}

GType
sound_get_type (void)
{
	static volatile gsize sound_type_id__once = 0;
	if (g_once_init_enter (&sound_type_id__once)) {
		GType sound_type_id;
		sound_type_id = sound_get_type_once ();
		g_once_init_leave (&sound_type_id__once, sound_type_id);
	}
	return sound_type_id__once;
}

static inline gpointer
sound_player_get_instance_private (SoundPlayer* self)
{
	return G_STRUCT_MEMBER_P (self, SoundPlayer_private_offset);
}

SoundPlayer*
sound_player_construct (GType object_type)
{
	SoundPlayer* self = NULL;
	GstPipeline* _tmp0_;
	GstPipeline* _tmp1_;
	GstElement* _tmp2_;
	GstElement* _tmp3_;
	GstPipeline* _tmp4_;
	GstElement* _tmp5_;
#line 34 "../src/sound-player.vala"
	self = (SoundPlayer*) g_type_create_instance (object_type);
#line 35 "../src/sound-player.vala"
	_tmp0_ = (GstPipeline*) gst_pipeline_new ("robots");
#line 35 "../src/sound-player.vala"
	g_object_ref_sink (_tmp0_);
#line 35 "../src/sound-player.vala"
	_g_object_unref0 (self->priv->pipeline);
#line 35 "../src/sound-player.vala"
	self->priv->pipeline = _tmp0_;
#line 36 "../src/sound-player.vala"
	_tmp1_ = self->priv->pipeline;
#line 36 "../src/sound-player.vala"
	g_return_if_fail (_tmp1_ != NULL);
#line 38 "../src/sound-player.vala"
	_tmp2_ = gst_element_factory_make ("playbin3", "play");
#line 38 "../src/sound-player.vala"
	if (_tmp2_ != NULL) {
#line 38 "../src/sound-player.vala"
		g_object_ref_sink (_tmp2_);
#line 181 "sound-player.c"
	}
#line 38 "../src/sound-player.vala"
	_g_object_unref0 (self->priv->playbin);
#line 38 "../src/sound-player.vala"
	self->priv->playbin = _tmp2_;
#line 39 "../src/sound-player.vala"
	_tmp3_ = self->priv->playbin;
#line 39 "../src/sound-player.vala"
	g_return_if_fail (_tmp3_ != NULL);
#line 41 "../src/sound-player.vala"
	_tmp4_ = self->priv->pipeline;
#line 41 "../src/sound-player.vala"
	_tmp5_ = self->priv->playbin;
#line 41 "../src/sound-player.vala"
	gst_bin_add ((GstBin*) _tmp4_, _tmp5_);
#line 34 "../src/sound-player.vala"
	return self;
#line 199 "sound-player.c"
}

SoundPlayer*
sound_player_new (void)
{
#line 34 "../src/sound-player.vala"
	return sound_player_construct (TYPE_SOUND_PLAYER);
#line 207 "sound-player.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 45 "../src/sound-player.vala"
	return self ? g_object_ref (self) : NULL;
#line 215 "sound-player.c"
}

void
sound_player_beep (SoundPlayer* self)
{
	GdkDisplay* display = NULL;
	GdkDisplay* _tmp0_;
	GdkDisplay* _tmp1_;
	GdkDisplay* _tmp2_;
#line 44 "../src/sound-player.vala"
	g_return_if_fail (self != NULL);
#line 45 "../src/sound-player.vala"
	_tmp0_ = gdk_display_get_default ();
#line 45 "../src/sound-player.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 45 "../src/sound-player.vala"
	display = _tmp1_;
#line 46 "../src/sound-player.vala"
	_tmp2_ = display;
#line 46 "../src/sound-player.vala"
	if (_tmp2_ != NULL) {
#line 237 "sound-player.c"
		GdkDisplay* _tmp3_;
#line 47 "../src/sound-player.vala"
		_tmp3_ = display;
#line 47 "../src/sound-player.vala"
		gdk_display_beep (_tmp3_);
#line 243 "sound-player.c"
	}
#line 44 "../src/sound-player.vala"
	_g_object_unref0 (display);
#line 247 "sound-player.c"
}

void
sound_player_play_file (SoundPlayer* self,
                        const gchar* name)
{
	GstPipeline* _tmp0_;
	GstElement* _tmp1_;
	gchar* filename = NULL;
	gchar* _tmp2_;
	gchar* path = NULL;
	const gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* uri = NULL;
	GstPipeline* _tmp12_;
	GstElement* _tmp13_;
	const gchar* _tmp14_;
	GValue _tmp15_ = {0};
	GstPipeline* _tmp16_;
	GError* _inner_error0_ = NULL;
#line 51 "../src/sound-player.vala"
	g_return_if_fail (self != NULL);
#line 51 "../src/sound-player.vala"
	g_return_if_fail (name != NULL);
#line 52 "../src/sound-player.vala"
	_tmp0_ = self->priv->pipeline;
#line 52 "../src/sound-player.vala"
	g_return_if_fail (_tmp0_ != NULL);
#line 53 "../src/sound-player.vala"
	_tmp1_ = self->priv->playbin;
#line 53 "../src/sound-player.vala"
	g_return_if_fail (_tmp1_ != NULL);
#line 55 "../src/sound-player.vala"
	_tmp2_ = g_strdup_printf ("%s.ogg", name);
#line 55 "../src/sound-player.vala"
	filename = _tmp2_;
#line 56 "../src/sound-player.vala"
	_tmp3_ = filename;
#line 56 "../src/sound-player.vala"
	_tmp4_ = g_build_filename (SOUND_DIRECTORY, _tmp3_, NULL);
#line 56 "../src/sound-player.vala"
	path = _tmp4_;
#line 290 "sound-player.c"
	{
		gchar* _tmp5_ = NULL;
		const gchar* _tmp6_;
		gchar* _tmp7_;
		gchar* _tmp8_;
#line 60 "../src/sound-player.vala"
		_tmp6_ = path;
#line 60 "../src/sound-player.vala"
		_tmp7_ = g_filename_to_uri (_tmp6_, NULL, &_inner_error0_);
#line 60 "../src/sound-player.vala"
		_tmp5_ = _tmp7_;
#line 60 "../src/sound-player.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 304 "sound-player.c"
			goto __catch0_g_error;
		}
#line 60 "../src/sound-player.vala"
		_tmp8_ = _tmp5_;
#line 60 "../src/sound-player.vala"
		_tmp5_ = NULL;
#line 60 "../src/sound-player.vala"
		_g_free0 (uri);
#line 60 "../src/sound-player.vala"
		uri = _tmp8_;
#line 59 "../src/sound-player.vala"
		_g_free0 (_tmp5_);
#line 317 "sound-player.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* _error_ = NULL;
		const gchar* _tmp9_;
		GError* _tmp10_;
		const gchar* _tmp11_;
#line 59 "../src/sound-player.vala"
		_error_ = _inner_error0_;
#line 59 "../src/sound-player.vala"
		_inner_error0_ = NULL;
#line 62 "../src/sound-player.vala"
		_tmp9_ = path;
#line 62 "../src/sound-player.vala"
		_tmp10_ = _error_;
#line 62 "../src/sound-player.vala"
		_tmp11_ = _tmp10_->message;
#line 62 "../src/sound-player.vala"
		g_warning ("sound-player.vala:62: Failed to convert a path '%s' to an URI. %s", _tmp9_, _tmp11_);
#line 63 "../src/sound-player.vala"
		_g_error_free0 (_error_);
#line 63 "../src/sound-player.vala"
		_g_free0 (uri);
#line 63 "../src/sound-player.vala"
		_g_free0 (path);
#line 63 "../src/sound-player.vala"
		_g_free0 (filename);
#line 63 "../src/sound-player.vala"
		return;
#line 348 "sound-player.c"
	}
	__finally0:
#line 59 "../src/sound-player.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 59 "../src/sound-player.vala"
		_g_free0 (uri);
#line 59 "../src/sound-player.vala"
		_g_free0 (path);
#line 59 "../src/sound-player.vala"
		_g_free0 (filename);
#line 59 "../src/sound-player.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 59 "../src/sound-player.vala"
		g_clear_error (&_inner_error0_);
#line 59 "../src/sound-player.vala"
		return;
#line 365 "sound-player.c"
	}
#line 66 "../src/sound-player.vala"
	_tmp12_ = self->priv->pipeline;
#line 66 "../src/sound-player.vala"
	gst_element_set_state ((GstElement*) _tmp12_, GST_STATE_NULL);
#line 67 "../src/sound-player.vala"
	_tmp13_ = self->priv->playbin;
#line 67 "../src/sound-player.vala"
	_tmp14_ = uri;
#line 67 "../src/sound-player.vala"
	g_value_init (&_tmp15_, G_TYPE_STRING);
#line 67 "../src/sound-player.vala"
	g_value_set_string (&_tmp15_, _tmp14_);
#line 67 "../src/sound-player.vala"
	g_object_set_property ((GObject*) _tmp13_, "uri", &_tmp15_);
#line 67 "../src/sound-player.vala"
	G_IS_VALUE (&_tmp15_) ? (g_value_unset (&_tmp15_), NULL) : NULL;
#line 68 "../src/sound-player.vala"
	_tmp16_ = self->priv->pipeline;
#line 68 "../src/sound-player.vala"
	gst_element_set_state ((GstElement*) _tmp16_, GST_STATE_PLAYING);
#line 51 "../src/sound-player.vala"
	_g_free0 (uri);
#line 51 "../src/sound-player.vala"
	_g_free0 (path);
#line 51 "../src/sound-player.vala"
	_g_free0 (filename);
#line 393 "sound-player.c"
}

void
sound_player_play (SoundPlayer* self,
                   Sound sound)
{
#line 71 "../src/sound-player.vala"
	g_return_if_fail (self != NULL);
#line 72 "../src/sound-player.vala"
	switch (sound) {
#line 72 "../src/sound-player.vala"
		case SOUND_VICTORY:
#line 406 "sound-player.c"
		{
#line 74 "../src/sound-player.vala"
			sound_player_play_file (self, "victory");
#line 75 "../src/sound-player.vala"
			break;
#line 412 "sound-player.c"
		}
#line 72 "../src/sound-player.vala"
		case SOUND_DIE:
#line 416 "sound-player.c"
		{
#line 77 "../src/sound-player.vala"
			sound_player_play_file (self, "die");
#line 78 "../src/sound-player.vala"
			break;
#line 422 "sound-player.c"
		}
#line 72 "../src/sound-player.vala"
		case SOUND_TELEPORT:
#line 426 "sound-player.c"
		{
#line 80 "../src/sound-player.vala"
			sound_player_play_file (self, "teleport");
#line 81 "../src/sound-player.vala"
			break;
#line 432 "sound-player.c"
		}
#line 72 "../src/sound-player.vala"
		case SOUND_SPLAT:
#line 436 "sound-player.c"
		{
#line 83 "../src/sound-player.vala"
			sound_player_play_file (self, "splat");
#line 84 "../src/sound-player.vala"
			break;
#line 442 "sound-player.c"
		}
#line 72 "../src/sound-player.vala"
		case SOUND_YAHOO:
#line 446 "sound-player.c"
		{
#line 86 "../src/sound-player.vala"
			sound_player_play_file (self, "yahoo");
#line 87 "../src/sound-player.vala"
			break;
#line 452 "sound-player.c"
		}
#line 72 "../src/sound-player.vala"
		case SOUND_BAD:
#line 456 "sound-player.c"
		{
#line 89 "../src/sound-player.vala"
			sound_player_beep (self);
#line 90 "../src/sound-player.vala"
			break;
#line 462 "sound-player.c"
		}
		default:
#line 72 "../src/sound-player.vala"
		break;
#line 467 "sound-player.c"
	}
}

static void
value_sound_player_init (GValue* value)
{
#line 29 "../src/sound-player.vala"
	value->data[0].v_pointer = NULL;
#line 476 "sound-player.c"
}

static void
value_sound_player_free_value (GValue* value)
{
#line 29 "../src/sound-player.vala"
	if (value->data[0].v_pointer) {
#line 29 "../src/sound-player.vala"
		sound_player_unref (value->data[0].v_pointer);
#line 486 "sound-player.c"
	}
}

static void
value_sound_player_copy_value (const GValue* src_value,
                               GValue* dest_value)
{
#line 29 "../src/sound-player.vala"
	if (src_value->data[0].v_pointer) {
#line 29 "../src/sound-player.vala"
		dest_value->data[0].v_pointer = sound_player_ref (src_value->data[0].v_pointer);
#line 498 "sound-player.c"
	} else {
#line 29 "../src/sound-player.vala"
		dest_value->data[0].v_pointer = NULL;
#line 502 "sound-player.c"
	}
}

static gpointer
value_sound_player_peek_pointer (const GValue* value)
{
#line 29 "../src/sound-player.vala"
	return value->data[0].v_pointer;
#line 511 "sound-player.c"
}

static gchar*
value_sound_player_collect_value (GValue* value,
                                  guint n_collect_values,
                                  GTypeCValue* collect_values,
                                  guint collect_flags)
{
#line 29 "../src/sound-player.vala"
	if (collect_values[0].v_pointer) {
#line 522 "sound-player.c"
		SoundPlayer * object;
		object = collect_values[0].v_pointer;
#line 29 "../src/sound-player.vala"
		if (object->parent_instance.g_class == NULL) {
#line 29 "../src/sound-player.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 529 "sound-player.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 29 "../src/sound-player.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 533 "sound-player.c"
		}
#line 29 "../src/sound-player.vala"
		value->data[0].v_pointer = sound_player_ref (object);
#line 537 "sound-player.c"
	} else {
#line 29 "../src/sound-player.vala"
		value->data[0].v_pointer = NULL;
#line 541 "sound-player.c"
	}
#line 29 "../src/sound-player.vala"
	return NULL;
#line 545 "sound-player.c"
}

static gchar*
value_sound_player_lcopy_value (const GValue* value,
                                guint n_collect_values,
                                GTypeCValue* collect_values,
                                guint collect_flags)
{
	SoundPlayer ** object_p;
	object_p = collect_values[0].v_pointer;
#line 29 "../src/sound-player.vala"
	if (!object_p) {
#line 29 "../src/sound-player.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 560 "sound-player.c"
	}
#line 29 "../src/sound-player.vala"
	if (!value->data[0].v_pointer) {
#line 29 "../src/sound-player.vala"
		*object_p = NULL;
#line 566 "sound-player.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 29 "../src/sound-player.vala"
		*object_p = value->data[0].v_pointer;
#line 570 "sound-player.c"
	} else {
#line 29 "../src/sound-player.vala"
		*object_p = sound_player_ref (value->data[0].v_pointer);
#line 574 "sound-player.c"
	}
#line 29 "../src/sound-player.vala"
	return NULL;
#line 578 "sound-player.c"
}

GParamSpec*
param_spec_sound_player (const gchar* name,
                         const gchar* nick,
                         const gchar* blurb,
                         GType object_type,
                         GParamFlags flags)
{
	ParamSpecSoundPlayer* spec;
#line 29 "../src/sound-player.vala"
	g_return_val_if_fail (g_type_is_a (object_type, TYPE_SOUND_PLAYER), NULL);
#line 29 "../src/sound-player.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 29 "../src/sound-player.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 29 "../src/sound-player.vala"
	return G_PARAM_SPEC (spec);
#line 597 "sound-player.c"
}

gpointer
value_get_sound_player (const GValue* value)
{
#line 29 "../src/sound-player.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_SOUND_PLAYER), NULL);
#line 29 "../src/sound-player.vala"
	return value->data[0].v_pointer;
#line 607 "sound-player.c"
}

void
value_set_sound_player (GValue* value,
                        gpointer v_object)
{
	SoundPlayer * old;
#line 29 "../src/sound-player.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_SOUND_PLAYER));
#line 29 "../src/sound-player.vala"
	old = value->data[0].v_pointer;
#line 29 "../src/sound-player.vala"
	if (v_object) {
#line 29 "../src/sound-player.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_SOUND_PLAYER));
#line 29 "../src/sound-player.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 29 "../src/sound-player.vala"
		value->data[0].v_pointer = v_object;
#line 29 "../src/sound-player.vala"
		sound_player_ref (value->data[0].v_pointer);
#line 629 "sound-player.c"
	} else {
#line 29 "../src/sound-player.vala"
		value->data[0].v_pointer = NULL;
#line 633 "sound-player.c"
	}
#line 29 "../src/sound-player.vala"
	if (old) {
#line 29 "../src/sound-player.vala"
		sound_player_unref (old);
#line 639 "sound-player.c"
	}
}

void
value_take_sound_player (GValue* value,
                         gpointer v_object)
{
	SoundPlayer * old;
#line 29 "../src/sound-player.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_SOUND_PLAYER));
#line 29 "../src/sound-player.vala"
	old = value->data[0].v_pointer;
#line 29 "../src/sound-player.vala"
	if (v_object) {
#line 29 "../src/sound-player.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_SOUND_PLAYER));
#line 29 "../src/sound-player.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 29 "../src/sound-player.vala"
		value->data[0].v_pointer = v_object;
#line 660 "sound-player.c"
	} else {
#line 29 "../src/sound-player.vala"
		value->data[0].v_pointer = NULL;
#line 664 "sound-player.c"
	}
#line 29 "../src/sound-player.vala"
	if (old) {
#line 29 "../src/sound-player.vala"
		sound_player_unref (old);
#line 670 "sound-player.c"
	}
}

static void
sound_player_class_init (SoundPlayerClass * klass,
                         gpointer klass_data)
{
#line 29 "../src/sound-player.vala"
	sound_player_parent_class = g_type_class_peek_parent (klass);
#line 29 "../src/sound-player.vala"
	((SoundPlayerClass *) klass)->finalize = sound_player_finalize;
#line 29 "../src/sound-player.vala"
	g_type_class_adjust_private_offset (klass, &SoundPlayer_private_offset);
#line 684 "sound-player.c"
}

static void
sound_player_instance_init (SoundPlayer * self,
                            gpointer klass)
{
#line 29 "../src/sound-player.vala"
	self->priv = sound_player_get_instance_private (self);
#line 29 "../src/sound-player.vala"
	self->ref_count = 1;
#line 695 "sound-player.c"
}

static void
sound_player_finalize (SoundPlayer * obj)
{
	SoundPlayer * self;
#line 29 "../src/sound-player.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_SOUND_PLAYER, SoundPlayer);
#line 29 "../src/sound-player.vala"
	g_signal_handlers_destroy (self);
#line 31 "../src/sound-player.vala"
	_g_object_unref0 (self->priv->pipeline);
#line 32 "../src/sound-player.vala"
	_g_object_unref0 (self->priv->playbin);
#line 710 "sound-player.c"
}

static GType
sound_player_get_type_once (void)
{
	static const GTypeValueTable g_define_type_value_table = { value_sound_player_init, value_sound_player_free_value, value_sound_player_copy_value, value_sound_player_peek_pointer, "p", value_sound_player_collect_value, "p", value_sound_player_lcopy_value };
	static const GTypeInfo g_define_type_info = { sizeof (SoundPlayerClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) sound_player_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (SoundPlayer), 0, (GInstanceInitFunc) sound_player_instance_init, &g_define_type_value_table };
	static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
	GType sound_player_type_id;
	sound_player_type_id = g_type_register_fundamental (g_type_fundamental_next (), "SoundPlayer", &g_define_type_info, &g_define_type_fundamental_info, 0);
	SoundPlayer_private_offset = g_type_add_instance_private (sound_player_type_id, sizeof (SoundPlayerPrivate));
	return sound_player_type_id;
}

GType
sound_player_get_type (void)
{
	static volatile gsize sound_player_type_id__once = 0;
	if (g_once_init_enter (&sound_player_type_id__once)) {
		GType sound_player_type_id;
		sound_player_type_id = sound_player_get_type_once ();
		g_once_init_leave (&sound_player_type_id__once, sound_player_type_id);
	}
	return sound_player_type_id__once;
}

gpointer
sound_player_ref (gpointer instance)
{
	SoundPlayer * self;
	self = instance;
#line 29 "../src/sound-player.vala"
	g_atomic_int_inc (&self->ref_count);
#line 29 "../src/sound-player.vala"
	return instance;
#line 746 "sound-player.c"
}

void
sound_player_unref (gpointer instance)
{
	SoundPlayer * self;
	self = instance;
#line 29 "../src/sound-player.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 29 "../src/sound-player.vala"
		SOUND_PLAYER_GET_CLASS (self)->finalize (self);
#line 29 "../src/sound-player.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 760 "sound-player.c"
	}
}

