/* theme.c generated by valac 0.56.16, the Vala compiler
 * generated from theme.vala, do not modify */

/*
 * Copyright 2020-2023 Andrey Kutejko <andy128k@gmail.com>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, see <http://www.gnu.org/licenses/>.
 *
 * For more details see the file COPYING.
 */

#include <glib-object.h>
#include <gdk/gdk.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <gtk/gtk.h>
#include <graphene-gobject.h>
#include <float.h>
#include <math.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define TYPE_THEME (theme_get_type ())
#define THEME(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_THEME, Theme))
#define THEME_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_THEME, ThemeClass))
#define IS_THEME(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_THEME))
#define IS_THEME_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_THEME))
#define THEME_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_THEME, ThemeClass))

typedef struct _Theme Theme;
typedef struct _ThemeClass ThemeClass;
typedef struct _ThemePrivate ThemePrivate;
enum  {
	THEME_0_PROPERTY,
	THEME_PATH_PROPERTY,
	THEME_NAME_PROPERTY,
	THEME_DISPLAY_NAME_PROPERTY,
	THEME_NUM_PROPERTIES
};
static GParamSpec* theme_properties[THEME_NUM_PROPERTIES];
typedef enum  {
	THEME_FRAMES_PLAYER_START = 0,
	THEME_FRAMES_PLAYER_DEAD = 4,
	THEME_FRAMES_ROBOT1_START = 5,
	THEME_FRAMES_ROBOT2_START = 9,
	THEME_FRAMES_HEAP_START = 13,
	THEME_FRAMES_COUNT = 14,
	THEME_FRAMES_NUM_PLAYER_ANIMATIONS = THEME_FRAMES_PLAYER_DEAD - THEME_FRAMES_PLAYER_START,
	THEME_FRAMES_NUM_PLAYER_DEAD_ANIMATIONS = THEME_FRAMES_ROBOT1_START - THEME_FRAMES_PLAYER_DEAD,
	THEME_FRAMES_NUM_PLAYER_TILES = THEME_FRAMES_ROBOT1_START - THEME_FRAMES_PLAYER_START,
	THEME_FRAMES_NUM_ROBOT1_ANIMATIONS = THEME_FRAMES_ROBOT2_START - THEME_FRAMES_ROBOT1_START,
	THEME_FRAMES_NUM_ROBOT2_ANIMATIONS = THEME_FRAMES_HEAP_START - THEME_FRAMES_ROBOT2_START,
	THEME_FRAMES_NUM_HEAP_ANIMATIONS = THEME_FRAMES_COUNT - THEME_FRAMES_HEAP_START
} ThemeFrames;

#define THEME_TYPE_FRAMES (theme_frames_get_type ())
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
typedef enum  {
	OBJECT_TYPE_PLAYER = 0,
	OBJECT_TYPE_HEAP = 1,
	OBJECT_TYPE_ROBOT1 = 2,
	OBJECT_TYPE_ROBOT2 = 3,
	OBJECT_TYPE_NONE = 99
} ObjectType;

#define TYPE_OBJECT_TYPE (object_type_get_type ())
#define _g_regex_unref0(var) ((var == NULL) ? NULL : (var = (g_regex_unref (var), NULL)))

struct _Theme {
	GObject parent_instance;
	ThemePrivate * priv;
};

struct _ThemeClass {
	GObjectClass parent_class;
};

struct _ThemePrivate {
	GdkPaintable* paintable;
	gchar* _path;
	gchar* _name;
};

static gint Theme_private_offset;
static gpointer theme_parent_class = NULL;

VALA_EXTERN GType theme_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Theme, g_object_unref)
VALA_EXTERN GType theme_frames_get_type (void) G_GNUC_CONST ;
VALA_EXTERN Theme* theme_new_from_file (const gchar* path,
                            const gchar* name,
                            GError** error);
VALA_EXTERN Theme* theme_construct_from_file (GType object_type,
                                  const gchar* path,
                                  const gchar* name,
                                  GError** error);
VALA_EXTERN GdkPaintable* image_from_file (const gchar* filename,
                               GError** error);
static void theme_set_path (Theme* self,
                     const gchar* value);
static void theme_set_name (Theme* self,
                     const gchar* value);
VALA_EXTERN GType object_type_get_type (void) G_GNUC_CONST ;
VALA_EXTERN void theme_draw_object (Theme* self,
                        ObjectType type,
                        gint frame_no,
                        GtkSnapshot* snapshot,
                        graphene_rect_t* rect);
VALA_EXTERN Theme* theme_new (void);
VALA_EXTERN Theme* theme_construct (GType object_type);
VALA_EXTERN const gchar* theme_get_path (Theme* self);
VALA_EXTERN const gchar* theme_get_name (Theme* self);
VALA_EXTERN gchar* theme_get_display_name (Theme* self);
VALA_EXTERN gchar* remove_suffix (const gchar* filename);
static void theme_finalize (GObject * obj);
static GType theme_get_type_once (void);
static void _vala_theme_get_property (GObject * object,
                               guint property_id,
                               GValue * value,
                               GParamSpec * pspec);
static void _vala_theme_set_property (GObject * object,
                               guint property_id,
                               const GValue * value,
                               GParamSpec * pspec);

static inline gpointer
theme_get_instance_private (Theme* self)
{
	return G_STRUCT_MEMBER_P (self, Theme_private_offset);
}

static GType
theme_frames_get_type_once (void)
{
	static const GEnumValue values[] = {{THEME_FRAMES_PLAYER_START, "THEME_FRAMES_PLAYER_START", "player-start"}, {THEME_FRAMES_PLAYER_DEAD, "THEME_FRAMES_PLAYER_DEAD", "player-dead"}, {THEME_FRAMES_ROBOT1_START, "THEME_FRAMES_ROBOT1_START", "robot1-start"}, {THEME_FRAMES_ROBOT2_START, "THEME_FRAMES_ROBOT2_START", "robot2-start"}, {THEME_FRAMES_HEAP_START, "THEME_FRAMES_HEAP_START", "heap-start"}, {THEME_FRAMES_COUNT, "THEME_FRAMES_COUNT", "count"}, {THEME_FRAMES_NUM_PLAYER_ANIMATIONS, "THEME_FRAMES_NUM_PLAYER_ANIMATIONS", "num-player-animations"}, {THEME_FRAMES_NUM_PLAYER_DEAD_ANIMATIONS, "THEME_FRAMES_NUM_PLAYER_DEAD_ANIMATIONS", "num-player-dead-animations"}, {THEME_FRAMES_NUM_PLAYER_TILES, "THEME_FRAMES_NUM_PLAYER_TILES", "num-player-tiles"}, {THEME_FRAMES_NUM_ROBOT1_ANIMATIONS, "THEME_FRAMES_NUM_ROBOT1_ANIMATIONS", "num-robot1-animations"}, {THEME_FRAMES_NUM_ROBOT2_ANIMATIONS, "THEME_FRAMES_NUM_ROBOT2_ANIMATIONS", "num-robot2-animations"}, {THEME_FRAMES_NUM_HEAP_ANIMATIONS, "THEME_FRAMES_NUM_HEAP_ANIMATIONS", "num-heap-animations"}, {0, NULL, NULL}};
	GType theme_frames_type_id;
	theme_frames_type_id = g_enum_register_static ("ThemeFrames", values);
	return theme_frames_type_id;
}

GType
theme_frames_get_type (void)
{
	static volatile gsize theme_frames_type_id__once = 0;
	if (g_once_init_enter (&theme_frames_type_id__once)) {
		GType theme_frames_type_id;
		theme_frames_type_id = theme_frames_get_type_once ();
		g_once_init_leave (&theme_frames_type_id__once, theme_frames_type_id);
	}
	return theme_frames_type_id__once;
}

Theme*
theme_construct_from_file (GType object_type,
                           const gchar* path,
                           const gchar* name,
                           GError** error)
{
	Theme * self = NULL;
	GdkPaintable* _tmp0_ = NULL;
	GdkPaintable* _tmp1_;
	GdkPaintable* _tmp2_;
	GError* _inner_error0_ = NULL;
#line 50 "../src/theme.vala"
	g_return_val_if_fail (path != NULL, NULL);
#line 50 "../src/theme.vala"
	g_return_val_if_fail (name != NULL, NULL);
#line 50 "../src/theme.vala"
	self = (Theme*) g_object_new (object_type, NULL);
#line 51 "../src/theme.vala"
	_tmp1_ = image_from_file (path, &_inner_error0_);
#line 51 "../src/theme.vala"
	_tmp0_ = _tmp1_;
#line 51 "../src/theme.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 51 "../src/theme.vala"
		g_propagate_error (error, _inner_error0_);
#line 51 "../src/theme.vala"
		_g_object_unref0 (self);
#line 51 "../src/theme.vala"
		return NULL;
#line 212 "theme.c"
	}
#line 51 "../src/theme.vala"
	_tmp2_ = _tmp0_;
#line 51 "../src/theme.vala"
	_tmp0_ = NULL;
#line 51 "../src/theme.vala"
	_g_object_unref0 (self->priv->paintable);
#line 51 "../src/theme.vala"
	self->priv->paintable = _tmp2_;
#line 52 "../src/theme.vala"
	theme_set_path (self, path);
#line 53 "../src/theme.vala"
	theme_set_name (self, name);
#line 50 "../src/theme.vala"
	_g_object_unref0 (_tmp0_);
#line 50 "../src/theme.vala"
	return self;
#line 230 "theme.c"
}

Theme*
theme_new_from_file (const gchar* path,
                     const gchar* name,
                     GError** error)
{
#line 50 "../src/theme.vala"
	return theme_construct_from_file (TYPE_THEME, path, name, error);
#line 240 "theme.c"
}

void
theme_draw_object (Theme* self,
                   ObjectType type,
                   gint frame_no,
                   GtkSnapshot* snapshot,
                   graphene_rect_t* rect)
{
	gint tile_no = 0;
	graphene_rect_t _tmp0_;
	graphene_rect_t _tmp1_;
	graphene_point_t _tmp2_;
	graphene_rect_t _tmp3_;
	graphene_size_t _tmp4_;
	graphene_rect_t _tmp5_;
	graphene_point_t _tmp6_;
	graphene_point_t _tmp7_ = {0};
	GdkPaintable* _tmp8_;
	graphene_rect_t _tmp9_;
	graphene_size_t _tmp10_;
	graphene_rect_t _tmp11_;
	graphene_size_t _tmp12_;
#line 56 "../src/theme.vala"
	g_return_if_fail (self != NULL);
#line 56 "../src/theme.vala"
	g_return_if_fail (snapshot != NULL);
#line 56 "../src/theme.vala"
	g_return_if_fail (rect != NULL);
#line 60 "../src/theme.vala"
	tile_no = -1;
#line 61 "../src/theme.vala"
	switch (type) {
#line 61 "../src/theme.vala"
		case OBJECT_TYPE_PLAYER:
#line 276 "theme.c"
		{
#line 63 "../src/theme.vala"
			tile_no = (gint) (THEME_FRAMES_PLAYER_START + (frame_no % THEME_FRAMES_NUM_PLAYER_TILES));
#line 64 "../src/theme.vala"
			break;
#line 282 "theme.c"
		}
#line 61 "../src/theme.vala"
		case OBJECT_TYPE_ROBOT1:
#line 286 "theme.c"
		{
#line 66 "../src/theme.vala"
			tile_no = (gint) (THEME_FRAMES_ROBOT1_START + (frame_no % THEME_FRAMES_NUM_ROBOT1_ANIMATIONS));
#line 67 "../src/theme.vala"
			break;
#line 292 "theme.c"
		}
#line 61 "../src/theme.vala"
		case OBJECT_TYPE_ROBOT2:
#line 296 "theme.c"
		{
#line 69 "../src/theme.vala"
			tile_no = (gint) (THEME_FRAMES_ROBOT2_START + (frame_no % THEME_FRAMES_NUM_ROBOT2_ANIMATIONS));
#line 70 "../src/theme.vala"
			break;
#line 302 "theme.c"
		}
#line 61 "../src/theme.vala"
		case OBJECT_TYPE_HEAP:
#line 306 "theme.c"
		{
#line 72 "../src/theme.vala"
			tile_no = (gint) (THEME_FRAMES_HEAP_START + (frame_no % THEME_FRAMES_NUM_HEAP_ANIMATIONS));
#line 73 "../src/theme.vala"
			break;
#line 312 "theme.c"
		}
#line 61 "../src/theme.vala"
		case OBJECT_TYPE_NONE:
#line 316 "theme.c"
		{
#line 75 "../src/theme.vala"
			return;
#line 320 "theme.c"
		}
		default:
#line 61 "../src/theme.vala"
		break;
#line 325 "theme.c"
	}
#line 78 "../src/theme.vala"
	_tmp0_ = *rect;
#line 78 "../src/theme.vala"
	gtk_snapshot_push_clip (snapshot, &_tmp0_);
#line 80 "../src/theme.vala"
	gtk_snapshot_save (snapshot);
#line 81 "../src/theme.vala"
	_tmp1_ = *rect;
#line 81 "../src/theme.vala"
	_tmp2_ = _tmp1_.origin;
#line 81 "../src/theme.vala"
	_tmp3_ = *rect;
#line 81 "../src/theme.vala"
	_tmp4_ = _tmp3_.size;
#line 81 "../src/theme.vala"
	_tmp5_ = *rect;
#line 81 "../src/theme.vala"
	_tmp6_ = _tmp5_.origin;
#line 81 "../src/theme.vala"
	memset (&_tmp7_, 0, sizeof (graphene_point_t));
#line 81 "../src/theme.vala"
	_tmp7_.x = _tmp2_.x - (tile_no * _tmp4_.width);
#line 81 "../src/theme.vala"
	_tmp7_.y = _tmp6_.y;
#line 81 "../src/theme.vala"
	gtk_snapshot_translate (snapshot, &_tmp7_);
#line 85 "../src/theme.vala"
	_tmp8_ = self->priv->paintable;
#line 85 "../src/theme.vala"
	_tmp9_ = *rect;
#line 85 "../src/theme.vala"
	_tmp10_ = _tmp9_.size;
#line 85 "../src/theme.vala"
	_tmp11_ = *rect;
#line 85 "../src/theme.vala"
	_tmp12_ = _tmp11_.size;
#line 85 "../src/theme.vala"
	gdk_paintable_snapshot (_tmp8_, (GdkSnapshot*) snapshot, (gdouble) (_tmp10_.width * THEME_FRAMES_COUNT), (gdouble) _tmp12_.height);
#line 86 "../src/theme.vala"
	gtk_snapshot_restore (snapshot);
#line 88 "../src/theme.vala"
	gtk_snapshot_pop (snapshot);
#line 369 "theme.c"
}

Theme*
theme_construct (GType object_type)
{
	Theme * self = NULL;
#line 25 "../src/theme.vala"
	self = (Theme*) g_object_new (object_type, NULL);
#line 25 "../src/theme.vala"
	return self;
#line 380 "theme.c"
}

Theme*
theme_new (void)
{
#line 25 "../src/theme.vala"
	return theme_construct (TYPE_THEME);
#line 388 "theme.c"
}

const gchar*
theme_get_path (Theme* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 44 "../src/theme.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 44 "../src/theme.vala"
	_tmp0_ = self->priv->_path;
#line 44 "../src/theme.vala"
	result = _tmp0_;
#line 44 "../src/theme.vala"
	return result;
#line 404 "theme.c"
}

static void
theme_set_path (Theme* self,
                const gchar* value)
{
	gchar* old_value;
#line 44 "../src/theme.vala"
	g_return_if_fail (self != NULL);
#line 44 "../src/theme.vala"
	old_value = theme_get_path (self);
#line 44 "../src/theme.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 418 "theme.c"
		gchar* _tmp0_;
#line 44 "../src/theme.vala"
		_tmp0_ = g_strdup (value);
#line 44 "../src/theme.vala"
		_g_free0 (self->priv->_path);
#line 44 "../src/theme.vala"
		self->priv->_path = _tmp0_;
#line 44 "../src/theme.vala"
		g_object_notify_by_pspec ((GObject *) self, theme_properties[THEME_PATH_PROPERTY]);
#line 428 "theme.c"
	}
}

const gchar*
theme_get_name (Theme* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 45 "../src/theme.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 45 "../src/theme.vala"
	_tmp0_ = self->priv->_name;
#line 45 "../src/theme.vala"
	result = _tmp0_;
#line 45 "../src/theme.vala"
	return result;
#line 445 "theme.c"
}

static void
theme_set_name (Theme* self,
                const gchar* value)
{
	gchar* old_value;
#line 45 "../src/theme.vala"
	g_return_if_fail (self != NULL);
#line 45 "../src/theme.vala"
	old_value = theme_get_name (self);
#line 45 "../src/theme.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 459 "theme.c"
		gchar* _tmp0_;
#line 45 "../src/theme.vala"
		_tmp0_ = g_strdup (value);
#line 45 "../src/theme.vala"
		_g_free0 (self->priv->_name);
#line 45 "../src/theme.vala"
		self->priv->_name = _tmp0_;
#line 45 "../src/theme.vala"
		g_object_notify_by_pspec ((GObject *) self, theme_properties[THEME_NAME_PROPERTY]);
#line 469 "theme.c"
	}
}

static gchar*
string_replace (const gchar* self,
                const gchar* old,
                const gchar* replacement)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	GError* _inner_error0_ = NULL;
	gchar* result;
#line 1553 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1553 "glib-2.0.vapi"
	g_return_val_if_fail (old != NULL, NULL);
#line 1553 "glib-2.0.vapi"
	g_return_val_if_fail (replacement != NULL, NULL);
#line 1554 "glib-2.0.vapi"
	if ((*((gchar*) self)) == '\0') {
#line 1554 "glib-2.0.vapi"
		_tmp1_ = TRUE;
#line 492 "theme.c"
	} else {
#line 1554 "glib-2.0.vapi"
		_tmp1_ = (*((gchar*) old)) == '\0';
#line 496 "theme.c"
	}
#line 1554 "glib-2.0.vapi"
	if (_tmp1_) {
#line 1554 "glib-2.0.vapi"
		_tmp0_ = TRUE;
#line 502 "theme.c"
	} else {
#line 1554 "glib-2.0.vapi"
		_tmp0_ = g_strcmp0 (old, replacement) == 0;
#line 506 "theme.c"
	}
#line 1554 "glib-2.0.vapi"
	if (_tmp0_) {
#line 510 "theme.c"
		gchar* _tmp2_;
#line 1555 "glib-2.0.vapi"
		_tmp2_ = g_strdup (self);
#line 1555 "glib-2.0.vapi"
		result = _tmp2_;
#line 1555 "glib-2.0.vapi"
		return result;
#line 518 "theme.c"
	}
	{
		GRegex* regex = NULL;
		gchar* _tmp3_;
		gchar* _tmp4_;
		GRegex* _tmp5_;
		GRegex* _tmp6_;
		gchar* _tmp7_ = NULL;
		GRegex* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
#line 1558 "glib-2.0.vapi"
		_tmp3_ = g_regex_escape_string (old, -1);
#line 1558 "glib-2.0.vapi"
		_tmp4_ = _tmp3_;
#line 1558 "glib-2.0.vapi"
		_tmp5_ = g_regex_new (_tmp4_, 0, 0, &_inner_error0_);
#line 1558 "glib-2.0.vapi"
		_tmp6_ = _tmp5_;
#line 1558 "glib-2.0.vapi"
		_g_free0 (_tmp4_);
#line 1558 "glib-2.0.vapi"
		regex = _tmp6_;
#line 1558 "glib-2.0.vapi"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1558 "glib-2.0.vapi"
			if (_inner_error0_->domain == G_REGEX_ERROR) {
#line 546 "theme.c"
				goto __catch0_g_regex_error;
			}
#line 1558 "glib-2.0.vapi"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1558 "glib-2.0.vapi"
			g_clear_error (&_inner_error0_);
#line 1558 "glib-2.0.vapi"
			return NULL;
#line 555 "theme.c"
		}
#line 1559 "glib-2.0.vapi"
		_tmp8_ = regex;
#line 1559 "glib-2.0.vapi"
		_tmp9_ = g_regex_replace_literal (_tmp8_, self, (gssize) -1, 0, replacement, 0, &_inner_error0_);
#line 1559 "glib-2.0.vapi"
		_tmp7_ = _tmp9_;
#line 1559 "glib-2.0.vapi"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1559 "glib-2.0.vapi"
			_g_regex_unref0 (regex);
#line 1559 "glib-2.0.vapi"
			if (_inner_error0_->domain == G_REGEX_ERROR) {
#line 569 "theme.c"
				goto __catch0_g_regex_error;
			}
#line 1559 "glib-2.0.vapi"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1559 "glib-2.0.vapi"
			g_clear_error (&_inner_error0_);
#line 1559 "glib-2.0.vapi"
			return NULL;
#line 578 "theme.c"
		}
#line 1559 "glib-2.0.vapi"
		_tmp10_ = _tmp7_;
#line 1559 "glib-2.0.vapi"
		_tmp7_ = NULL;
#line 1559 "glib-2.0.vapi"
		result = _tmp10_;
#line 1559 "glib-2.0.vapi"
		_g_free0 (_tmp7_);
#line 1559 "glib-2.0.vapi"
		_g_regex_unref0 (regex);
#line 1559 "glib-2.0.vapi"
		return result;
#line 592 "theme.c"
	}
	goto __finally0;
	__catch0_g_regex_error:
	{
#line 1557 "glib-2.0.vapi"
		g_clear_error (&_inner_error0_);
#line 1561 "glib-2.0.vapi"
		g_assert_not_reached ();
#line 601 "theme.c"
	}
	__finally0:
#line 1557 "glib-2.0.vapi"
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1557 "glib-2.0.vapi"
	g_clear_error (&_inner_error0_);
#line 1557 "glib-2.0.vapi"
	return NULL;
#line 610 "theme.c"
}

gchar*
theme_get_display_name (Theme* self)
{
	gchar* result;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
#line 47 "../src/theme.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 47 "../src/theme.vala"
	_tmp0_ = self->priv->_name;
#line 47 "../src/theme.vala"
	_tmp1_ = remove_suffix (_tmp0_);
#line 47 "../src/theme.vala"
	_tmp2_ = _tmp1_;
#line 47 "../src/theme.vala"
	_tmp3_ = string_replace (_tmp2_, "_", " ");
#line 47 "../src/theme.vala"
	_tmp4_ = _tmp3_;
#line 47 "../src/theme.vala"
	_g_free0 (_tmp2_);
#line 47 "../src/theme.vala"
	result = _tmp4_;
#line 47 "../src/theme.vala"
	return result;
#line 640 "theme.c"
}

static void
theme_class_init (ThemeClass * klass,
                  gpointer klass_data)
{
#line 25 "../src/theme.vala"
	theme_parent_class = g_type_class_peek_parent (klass);
#line 25 "../src/theme.vala"
	g_type_class_adjust_private_offset (klass, &Theme_private_offset);
#line 25 "../src/theme.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_theme_get_property;
#line 25 "../src/theme.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_theme_set_property;
#line 25 "../src/theme.vala"
	G_OBJECT_CLASS (klass)->finalize = theme_finalize;
#line 25 "../src/theme.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), THEME_PATH_PROPERTY, theme_properties[THEME_PATH_PROPERTY] = g_param_spec_string ("path", "path", "path", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 25 "../src/theme.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), THEME_NAME_PROPERTY, theme_properties[THEME_NAME_PROPERTY] = g_param_spec_string ("name", "name", "name", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 25 "../src/theme.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), THEME_DISPLAY_NAME_PROPERTY, theme_properties[THEME_DISPLAY_NAME_PROPERTY] = g_param_spec_string ("display-name", "display-name", "display-name", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 663 "theme.c"
}

static void
theme_instance_init (Theme * self,
                     gpointer klass)
{
#line 25 "../src/theme.vala"
	self->priv = theme_get_instance_private (self);
#line 672 "theme.c"
}

static void
theme_finalize (GObject * obj)
{
	Theme * self;
#line 25 "../src/theme.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_THEME, Theme);
#line 43 "../src/theme.vala"
	_g_object_unref0 (self->priv->paintable);
#line 44 "../src/theme.vala"
	_g_free0 (self->priv->_path);
#line 45 "../src/theme.vala"
	_g_free0 (self->priv->_name);
#line 25 "../src/theme.vala"
	G_OBJECT_CLASS (theme_parent_class)->finalize (obj);
#line 689 "theme.c"
}

static GType
theme_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (ThemeClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) theme_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (Theme), 0, (GInstanceInitFunc) theme_instance_init, NULL };
	GType theme_type_id;
	theme_type_id = g_type_register_static (G_TYPE_OBJECT, "Theme", &g_define_type_info, 0);
	Theme_private_offset = g_type_add_instance_private (theme_type_id, sizeof (ThemePrivate));
	return theme_type_id;
}

GType
theme_get_type (void)
{
	static volatile gsize theme_type_id__once = 0;
	if (g_once_init_enter (&theme_type_id__once)) {
		GType theme_type_id;
		theme_type_id = theme_get_type_once ();
		g_once_init_leave (&theme_type_id__once, theme_type_id);
	}
	return theme_type_id__once;
}

static void
_vala_theme_get_property (GObject * object,
                          guint property_id,
                          GValue * value,
                          GParamSpec * pspec)
{
	Theme * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_THEME, Theme);
#line 25 "../src/theme.vala"
	switch (property_id) {
#line 25 "../src/theme.vala"
		case THEME_PATH_PROPERTY:
#line 25 "../src/theme.vala"
		g_value_set_string (value, theme_get_path (self));
#line 25 "../src/theme.vala"
		break;
#line 25 "../src/theme.vala"
		case THEME_NAME_PROPERTY:
#line 25 "../src/theme.vala"
		g_value_set_string (value, theme_get_name (self));
#line 25 "../src/theme.vala"
		break;
#line 25 "../src/theme.vala"
		case THEME_DISPLAY_NAME_PROPERTY:
#line 25 "../src/theme.vala"
		g_value_take_string (value, theme_get_display_name (self));
#line 25 "../src/theme.vala"
		break;
#line 742 "theme.c"
		default:
#line 25 "../src/theme.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 25 "../src/theme.vala"
		break;
#line 748 "theme.c"
	}
}

static void
_vala_theme_set_property (GObject * object,
                          guint property_id,
                          const GValue * value,
                          GParamSpec * pspec)
{
	Theme * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_THEME, Theme);
#line 25 "../src/theme.vala"
	switch (property_id) {
#line 25 "../src/theme.vala"
		case THEME_PATH_PROPERTY:
#line 25 "../src/theme.vala"
		theme_set_path (self, g_value_get_string (value));
#line 25 "../src/theme.vala"
		break;
#line 25 "../src/theme.vala"
		case THEME_NAME_PROPERTY:
#line 25 "../src/theme.vala"
		theme_set_name (self, g_value_get_string (value));
#line 25 "../src/theme.vala"
		break;
#line 774 "theme.c"
		default:
#line 25 "../src/theme.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 25 "../src/theme.vala"
		break;
#line 780 "theme.c"
	}
}

static gint
string_last_index_of_char (const gchar* self,
                           gunichar c,
                           gint start_index)
{
	gchar* _result_ = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gint result;
#line 1179 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, 0);
#line 1180 "glib-2.0.vapi"
	_tmp0_ = g_utf8_strrchr (((gchar*) self) + start_index, (gssize) -1, c);
#line 1180 "glib-2.0.vapi"
	_result_ = _tmp0_;
#line 1182 "glib-2.0.vapi"
	_tmp1_ = _result_;
#line 1182 "glib-2.0.vapi"
	if (_tmp1_ != NULL) {
#line 803 "theme.c"
		gchar* _tmp2_;
#line 1183 "glib-2.0.vapi"
		_tmp2_ = _result_;
#line 1183 "glib-2.0.vapi"
		result = (gint) (_tmp2_ - ((gchar*) self));
#line 1183 "glib-2.0.vapi"
		return result;
#line 811 "theme.c"
	} else {
#line 1185 "glib-2.0.vapi"
		result = -1;
#line 1185 "glib-2.0.vapi"
		return result;
#line 817 "theme.c"
	}
}

static glong
string_strnlen (gchar* str,
                glong maxlen)
{
	gchar* end = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	glong result;
#line 1466 "glib-2.0.vapi"
	_tmp0_ = memchr (str, 0, (gsize) maxlen);
#line 1466 "glib-2.0.vapi"
	end = _tmp0_;
#line 1467 "glib-2.0.vapi"
	_tmp1_ = end;
#line 1467 "glib-2.0.vapi"
	if (_tmp1_ == NULL) {
#line 1468 "glib-2.0.vapi"
		result = maxlen;
#line 1468 "glib-2.0.vapi"
		return result;
#line 841 "theme.c"
	} else {
		gchar* _tmp2_;
#line 1470 "glib-2.0.vapi"
		_tmp2_ = end;
#line 1470 "glib-2.0.vapi"
		result = (glong) (_tmp2_ - str);
#line 1470 "glib-2.0.vapi"
		return result;
#line 850 "theme.c"
	}
}

static gchar*
string_substring (const gchar* self,
                  glong offset,
                  glong len)
{
	glong string_length = 0L;
	gboolean _tmp0_ = FALSE;
	gchar* _tmp3_;
	gchar* result;
#line 1477 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1479 "glib-2.0.vapi"
	if (offset >= ((glong) 0)) {
#line 1479 "glib-2.0.vapi"
		_tmp0_ = len >= ((glong) 0);
#line 869 "theme.c"
	} else {
#line 1479 "glib-2.0.vapi"
		_tmp0_ = FALSE;
#line 873 "theme.c"
	}
#line 1479 "glib-2.0.vapi"
	if (_tmp0_) {
#line 1481 "glib-2.0.vapi"
		string_length = string_strnlen ((gchar*) self, offset + len);
#line 879 "theme.c"
	} else {
		gint _tmp1_;
		gint _tmp2_;
#line 1483 "glib-2.0.vapi"
		_tmp1_ = strlen (self);
#line 1483 "glib-2.0.vapi"
		_tmp2_ = _tmp1_;
#line 1483 "glib-2.0.vapi"
		string_length = (glong) _tmp2_;
#line 889 "theme.c"
	}
#line 1486 "glib-2.0.vapi"
	if (offset < ((glong) 0)) {
#line 1487 "glib-2.0.vapi"
		offset = string_length + offset;
#line 1488 "glib-2.0.vapi"
		g_return_val_if_fail (offset >= ((glong) 0), NULL);
#line 897 "theme.c"
	} else {
#line 1490 "glib-2.0.vapi"
		g_return_val_if_fail (offset <= string_length, NULL);
#line 901 "theme.c"
	}
#line 1492 "glib-2.0.vapi"
	if (len < ((glong) 0)) {
#line 1493 "glib-2.0.vapi"
		len = string_length - offset;
#line 907 "theme.c"
	}
#line 1495 "glib-2.0.vapi"
	g_return_val_if_fail ((offset + len) <= string_length, NULL);
#line 1496 "glib-2.0.vapi"
	_tmp3_ = g_strndup (((gchar*) self) + offset, (gsize) len);
#line 1496 "glib-2.0.vapi"
	result = _tmp3_;
#line 1496 "glib-2.0.vapi"
	return result;
#line 917 "theme.c"
}

gchar*
remove_suffix (const gchar* filename)
{
	gint s = 0;
	gchar* result;
#line 92 "../src/theme.vala"
	g_return_val_if_fail (filename != NULL, NULL);
#line 93 "../src/theme.vala"
	s = string_last_index_of_char (filename, (gunichar) '.', 0);
#line 94 "../src/theme.vala"
	if (s >= 0) {
#line 931 "theme.c"
		gchar* _tmp0_;
#line 95 "../src/theme.vala"
		_tmp0_ = string_substring (filename, (glong) 0, (glong) s);
#line 95 "../src/theme.vala"
		result = _tmp0_;
#line 95 "../src/theme.vala"
		return result;
#line 939 "theme.c"
	} else {
		gchar* _tmp1_;
#line 97 "../src/theme.vala"
		_tmp1_ = g_strdup (filename);
#line 97 "../src/theme.vala"
		result = _tmp1_;
#line 97 "../src/theme.vala"
		return result;
#line 948 "theme.c"
	}
}

