/* themes.c generated by valac 0.56.16, the Vala compiler
 * generated from themes.vala, do not modify */

/*
 * Copyright 2020-2023 Andrey Kutejko <andy128k@gmail.com>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, see <http://www.gnu.org/licenses/>.
 *
 * For more details see the file COPYING.
 */

#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <gio/gio.h>
#include <glib-object.h>
#include <glib/gstdio.h>

#define THEMES_DEFAULT_THEME "robots.svg"
#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define TYPE_THEME (theme_get_type ())
#define THEME(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_THEME, Theme))
#define THEME_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_THEME, ThemeClass))
#define IS_THEME(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_THEME))
#define IS_THEME_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_THEME))
#define THEME_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_THEME, ThemeClass))

typedef struct _Theme Theme;
typedef struct _ThemeClass ThemeClass;
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_dir_close0(var) ((var == NULL) ? NULL : (var = (g_dir_close (var), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))

#define THEMES_TYPE_THEME_RESULT (themes_theme_result_get_type ())
typedef struct _ThemesThemeResult ThemesThemeResult;
#define _themes_theme_result_free0(var) ((var == NULL) ? NULL : (var = (themes_theme_result_free (var), NULL)))

struct _ThemesThemeResult {
	guint index;
	Theme* theme;
};

VALA_EXTERN GListStore* themes_from_directory (const gchar* directory);
VALA_EXTERN GType theme_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Theme, g_object_unref)
VALA_EXTERN gboolean image_suffix_list_has_image_suffix (const gchar* filename);
VALA_EXTERN Theme* theme_new_from_file (const gchar* path,
                            const gchar* name,
                            GError** error);
VALA_EXTERN Theme* theme_construct_from_file (GType object_type,
                                  const gchar* path,
                                  const gchar* name,
                                  GError** error);
VALA_EXTERN GType themes_theme_result_get_type (void) G_GNUC_CONST ;
VALA_EXTERN ThemesThemeResult* themes_theme_result_dup (const ThemesThemeResult* self);
VALA_EXTERN void themes_theme_result_free (ThemesThemeResult* self);
VALA_EXTERN void themes_theme_result_copy (const ThemesThemeResult* self,
                               ThemesThemeResult* dest);
VALA_EXTERN void themes_theme_result_destroy (ThemesThemeResult* self);
G_DEFINE_AUTO_CLEANUP_CLEAR_FUNC (ThemesThemeResult, themes_theme_result_destroy)
VALA_EXTERN ThemesThemeResult* themes_find_by_name (GListModel* themes,
                                        const gchar* name);
VALA_EXTERN const gchar* theme_get_name (Theme* self);
VALA_EXTERN Theme* themes_find_best_match (GListModel* themes,
                               const gchar* name,
                               GError** error);

GListStore*
themes_from_directory (const gchar* directory)
{
	GListStore* themes = NULL;
	GListStore* _tmp0_;
	GError* _inner_error0_ = NULL;
	GListStore* result;
#line 22 "../src/themes.vala"
	g_return_val_if_fail (directory != NULL, NULL);
#line 23 "../src/themes.vala"
	_tmp0_ = g_list_store_new (TYPE_THEME);
#line 23 "../src/themes.vala"
	themes = _tmp0_;
#line 111 "themes.c"
	{
		GDir* dir = NULL;
		GDir* _tmp1_;
		gchar* filename = NULL;
#line 25 "../src/themes.vala"
		_tmp1_ = g_dir_open (directory, (guint) 0, &_inner_error0_);
#line 25 "../src/themes.vala"
		dir = _tmp1_;
#line 25 "../src/themes.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 122 "themes.c"
			goto __catch0_g_error;
		}
#line 27 "../src/themes.vala"
		while (TRUE) {
#line 127 "themes.c"
			GDir* _tmp2_;
			const gchar* _tmp3_;
			gchar* _tmp4_;
			const gchar* _tmp5_;
			const gchar* _tmp6_;
#line 27 "../src/themes.vala"
			_tmp2_ = dir;
#line 27 "../src/themes.vala"
			_tmp3_ = g_dir_read_name (_tmp2_);
#line 27 "../src/themes.vala"
			_tmp4_ = g_strdup (_tmp3_);
#line 27 "../src/themes.vala"
			_g_free0 (filename);
#line 27 "../src/themes.vala"
			filename = _tmp4_;
#line 27 "../src/themes.vala"
			_tmp5_ = filename;
#line 27 "../src/themes.vala"
			if (!(_tmp5_ != NULL)) {
#line 27 "../src/themes.vala"
				break;
#line 149 "themes.c"
			}
#line 28 "../src/themes.vala"
			_tmp6_ = filename;
#line 28 "../src/themes.vala"
			if (image_suffix_list_has_image_suffix (_tmp6_)) {
#line 155 "themes.c"
				gchar* path = NULL;
				const gchar* _tmp7_;
				gchar* _tmp8_;
				const gchar* _tmp9_;
#line 29 "../src/themes.vala"
				_tmp7_ = filename;
#line 29 "../src/themes.vala"
				_tmp8_ = g_build_filename (directory, _tmp7_, NULL);
#line 29 "../src/themes.vala"
				path = _tmp8_;
#line 30 "../src/themes.vala"
				_tmp9_ = path;
#line 30 "../src/themes.vala"
				if (g_file_test (_tmp9_, G_FILE_TEST_IS_REGULAR)) {
#line 170 "themes.c"
					Theme* theme = NULL;
					const gchar* _tmp10_;
					const gchar* _tmp11_;
					Theme* _tmp12_;
					GListStore* _tmp13_;
					Theme* _tmp14_;
#line 31 "../src/themes.vala"
					_tmp10_ = path;
#line 31 "../src/themes.vala"
					_tmp11_ = filename;
#line 31 "../src/themes.vala"
					_tmp12_ = theme_new_from_file (_tmp10_, _tmp11_, &_inner_error0_);
#line 31 "../src/themes.vala"
					theme = _tmp12_;
#line 31 "../src/themes.vala"
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 31 "../src/themes.vala"
						_g_free0 (path);
#line 31 "../src/themes.vala"
						_g_free0 (filename);
#line 31 "../src/themes.vala"
						_g_dir_close0 (dir);
#line 193 "themes.c"
						goto __catch0_g_error;
					}
#line 32 "../src/themes.vala"
					_tmp13_ = themes;
#line 32 "../src/themes.vala"
					_tmp14_ = theme;
#line 32 "../src/themes.vala"
					g_list_store_append (_tmp13_, (GObject*) _tmp14_);
#line 30 "../src/themes.vala"
					_g_object_unref0 (theme);
#line 204 "themes.c"
				}
#line 28 "../src/themes.vala"
				_g_free0 (path);
#line 208 "themes.c"
			}
		}
#line 24 "../src/themes.vala"
		_g_free0 (filename);
#line 24 "../src/themes.vala"
		_g_dir_close0 (dir);
#line 215 "themes.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp15_;
		const gchar* _tmp16_;
#line 24 "../src/themes.vala"
		e = _inner_error0_;
#line 24 "../src/themes.vala"
		_inner_error0_ = NULL;
#line 37 "../src/themes.vala"
		_tmp15_ = e;
#line 37 "../src/themes.vala"
		_tmp16_ = _tmp15_->message;
#line 37 "../src/themes.vala"
		g_warning ("themes.vala:37: Themes.from_directory: %s.", _tmp16_);
#line 24 "../src/themes.vala"
		_g_error_free0 (e);
#line 235 "themes.c"
	}
	__finally0:
#line 24 "../src/themes.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 24 "../src/themes.vala"
		_g_object_unref0 (themes);
#line 24 "../src/themes.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 24 "../src/themes.vala"
		g_clear_error (&_inner_error0_);
#line 24 "../src/themes.vala"
		return NULL;
#line 248 "themes.c"
	}
#line 39 "../src/themes.vala"
	result = themes;
#line 39 "../src/themes.vala"
	return result;
#line 254 "themes.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 42 "../src/themes.vala"
	return self ? g_object_ref (self) : NULL;
#line 262 "themes.c"
}

void
themes_theme_result_copy (const ThemesThemeResult* self,
                          ThemesThemeResult* dest)
{
	Theme* _tmp0_;
	Theme* _tmp1_;
#line 42 "../src/themes.vala"
	(*dest).index = (*self).index;
#line 42 "../src/themes.vala"
	_tmp0_ = (*self).theme;
#line 42 "../src/themes.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 42 "../src/themes.vala"
	_g_object_unref0 ((*dest).theme);
#line 42 "../src/themes.vala"
	(*dest).theme = _tmp1_;
#line 281 "themes.c"
}

void
themes_theme_result_destroy (ThemesThemeResult* self)
{
#line 44 "../src/themes.vala"
	_g_object_unref0 ((*self).theme);
#line 289 "themes.c"
}

ThemesThemeResult*
themes_theme_result_dup (const ThemesThemeResult* self)
{
	ThemesThemeResult* dup;
#line 42 "../src/themes.vala"
	dup = g_new0 (ThemesThemeResult, 1);
#line 42 "../src/themes.vala"
	themes_theme_result_copy (self, dup);
#line 42 "../src/themes.vala"
	return dup;
#line 302 "themes.c"
}

void
themes_theme_result_free (ThemesThemeResult* self)
{
#line 42 "../src/themes.vala"
	themes_theme_result_destroy (self);
#line 42 "../src/themes.vala"
	g_free (self);
#line 312 "themes.c"
}

static GType
themes_theme_result_get_type_once (void)
{
	GType themes_theme_result_type_id;
	themes_theme_result_type_id = g_boxed_type_register_static ("ThemesThemeResult", (GBoxedCopyFunc) themes_theme_result_dup, (GBoxedFreeFunc) themes_theme_result_free);
	return themes_theme_result_type_id;
}

GType
themes_theme_result_get_type (void)
{
	static volatile gsize themes_theme_result_type_id__once = 0;
	if (g_once_init_enter (&themes_theme_result_type_id__once)) {
		GType themes_theme_result_type_id;
		themes_theme_result_type_id = themes_theme_result_get_type_once ();
		g_once_init_leave (&themes_theme_result_type_id__once, themes_theme_result_type_id);
	}
	return themes_theme_result_type_id__once;
}

static gpointer
_themes_theme_result_dup0 (gpointer self)
{
#line 52 "../src/themes.vala"
	return self ? themes_theme_result_dup (self) : NULL;
#line 340 "themes.c"
}

ThemesThemeResult*
themes_find_by_name (GListModel* themes,
                     const gchar* name)
{
	guint size = 0U;
	ThemesThemeResult* result;
#line 47 "../src/themes.vala"
	g_return_val_if_fail (themes != NULL, NULL);
#line 47 "../src/themes.vala"
	g_return_val_if_fail (name != NULL, NULL);
#line 48 "../src/themes.vala"
	size = g_list_model_get_n_items (themes);
#line 355 "themes.c"
	{
		gint index = 0;
#line 49 "../src/themes.vala"
		index = 0;
#line 360 "themes.c"
		{
			gboolean _tmp0_ = FALSE;
#line 49 "../src/themes.vala"
			_tmp0_ = TRUE;
#line 49 "../src/themes.vala"
			while (TRUE) {
#line 367 "themes.c"
				Theme* theme = NULL;
				GObject* _tmp2_;
				Theme* _tmp3_;
				const gchar* _tmp4_;
				const gchar* _tmp5_;
#line 49 "../src/themes.vala"
				if (!_tmp0_) {
#line 375 "themes.c"
					gint _tmp1_;
#line 49 "../src/themes.vala"
					index = index + 1;
#line 49 "../src/themes.vala"
					_tmp1_ = index;
#line 381 "themes.c"
				}
#line 49 "../src/themes.vala"
				_tmp0_ = FALSE;
#line 49 "../src/themes.vala"
				if (!(((guint) index) < size)) {
#line 49 "../src/themes.vala"
					break;
#line 389 "themes.c"
				}
#line 50 "../src/themes.vala"
				_tmp2_ = g_list_model_get_item (themes, (guint) index);
#line 50 "../src/themes.vala"
				theme = G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, TYPE_THEME, Theme);
#line 51 "../src/themes.vala"
				_tmp3_ = theme;
#line 51 "../src/themes.vala"
				_tmp4_ = theme_get_name (_tmp3_);
#line 51 "../src/themes.vala"
				_tmp5_ = _tmp4_;
#line 51 "../src/themes.vala"
				if (g_strcmp0 (_tmp5_, name) == 0) {
#line 403 "themes.c"
					Theme* _tmp6_;
					Theme* _tmp7_;
					ThemesThemeResult _tmp8_ = {0};
					ThemesThemeResult _tmp9_;
					ThemesThemeResult* _tmp10_;
					ThemesThemeResult* _tmp11_;
#line 52 "../src/themes.vala"
					_tmp6_ = theme;
#line 52 "../src/themes.vala"
					_tmp7_ = _g_object_ref0 (_tmp6_);
#line 52 "../src/themes.vala"
					memset (&_tmp8_, 0, sizeof (ThemesThemeResult));
#line 52 "../src/themes.vala"
					_tmp8_.index = (guint) index;
#line 52 "../src/themes.vala"
					_g_object_unref0 (_tmp8_.theme);
#line 52 "../src/themes.vala"
					_tmp8_.theme = _tmp7_;
#line 52 "../src/themes.vala"
					_tmp9_ = _tmp8_;
#line 52 "../src/themes.vala"
					_tmp10_ = _themes_theme_result_dup0 (&_tmp9_);
#line 52 "../src/themes.vala"
					_tmp11_ = _tmp10_;
#line 52 "../src/themes.vala"
					themes_theme_result_destroy (&_tmp9_);
#line 52 "../src/themes.vala"
					result = _tmp11_;
#line 52 "../src/themes.vala"
					_g_object_unref0 (theme);
#line 52 "../src/themes.vala"
					return result;
#line 436 "themes.c"
				}
#line 49 "../src/themes.vala"
				_g_object_unref0 (theme);
#line 440 "themes.c"
			}
		}
	}
#line 55 "../src/themes.vala"
	result = NULL;
#line 55 "../src/themes.vala"
	return result;
#line 448 "themes.c"
}

Theme*
themes_find_best_match (GListModel* themes,
                        const gchar* name,
                        GError** error)
{
	ThemesThemeResult* named = NULL;
	ThemesThemeResult* _tmp0_;
	ThemesThemeResult* _tmp1_;
	ThemesThemeResult* deflt = NULL;
	ThemesThemeResult* _tmp5_;
	ThemesThemeResult* _tmp6_;
	GError* _tmp10_;
	GError* _inner_error0_ = NULL;
	Theme* result;
#line 60 "../src/themes.vala"
	g_return_val_if_fail (themes != NULL, NULL);
#line 60 "../src/themes.vala"
	g_return_val_if_fail (name != NULL, NULL);
#line 61 "../src/themes.vala"
	_tmp0_ = themes_find_by_name (themes, name);
#line 61 "../src/themes.vala"
	named = _tmp0_;
#line 62 "../src/themes.vala"
	_tmp1_ = named;
#line 62 "../src/themes.vala"
	if (_tmp1_ != NULL) {
#line 477 "themes.c"
		ThemesThemeResult* _tmp2_;
		Theme* _tmp3_;
		Theme* _tmp4_;
#line 63 "../src/themes.vala"
		_tmp2_ = named;
#line 63 "../src/themes.vala"
		_tmp3_ = (*_tmp2_).theme;
#line 63 "../src/themes.vala"
		_tmp4_ = _g_object_ref0 (_tmp3_);
#line 63 "../src/themes.vala"
		result = _tmp4_;
#line 63 "../src/themes.vala"
		_themes_theme_result_free0 (named);
#line 63 "../src/themes.vala"
		return result;
#line 493 "themes.c"
	}
#line 65 "../src/themes.vala"
	_tmp5_ = themes_find_by_name (themes, THEMES_DEFAULT_THEME);
#line 65 "../src/themes.vala"
	deflt = _tmp5_;
#line 66 "../src/themes.vala"
	_tmp6_ = deflt;
#line 66 "../src/themes.vala"
	if (_tmp6_ != NULL) {
#line 503 "themes.c"
		ThemesThemeResult* _tmp7_;
		Theme* _tmp8_;
		Theme* _tmp9_;
#line 67 "../src/themes.vala"
		_tmp7_ = deflt;
#line 67 "../src/themes.vala"
		_tmp8_ = (*_tmp7_).theme;
#line 67 "../src/themes.vala"
		_tmp9_ = _g_object_ref0 (_tmp8_);
#line 67 "../src/themes.vala"
		result = _tmp9_;
#line 67 "../src/themes.vala"
		_themes_theme_result_free0 (deflt);
#line 67 "../src/themes.vala"
		_themes_theme_result_free0 (named);
#line 67 "../src/themes.vala"
		return result;
#line 521 "themes.c"
	}
#line 69 "../src/themes.vala"
	_tmp10_ = g_error_new_literal (G_FILE_ERROR, G_FILE_ERROR_NOENT, "No theme was found.");
#line 69 "../src/themes.vala"
	_inner_error0_ = _tmp10_;
#line 69 "../src/themes.vala"
	g_propagate_error (error, _inner_error0_);
#line 69 "../src/themes.vala"
	_themes_theme_result_free0 (deflt);
#line 69 "../src/themes.vala"
	_themes_theme_result_free0 (named);
#line 69 "../src/themes.vala"
	return NULL;
#line 535 "themes.c"
}

